/* Copyright (c) 1996, Tristan Savatier */
#ifndef _mpeg_values_h
#define _mpeg_values_h
#ifndef lint
static const char rcsid_mpeg_values_h[] = "$Header: /net/hopkins/var/home/tristan/mpeg/include/RCS/mpeg_values.h,v 1.4 1998/05/29 22:48:21 tristan Exp $";
#endif


/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

/*
 * Do not use this file unless <values.h> is missing from your system.
 */

/*	based on: @(#)values.h 1.4 88/02/07 SMI; from S5R2 1.16	*/
 
#ifndef BITSPERBYTE
/* These values work with any binary representation of integers
 * where the high-order bit contains the sign. */

/* a number used normally for size of a shift */
#if gcos
#define BITSPERBYTE	9
#else
#define BITSPERBYTE	8
#endif
#endif

#ifndef BITS
#define BITS(type)	(BITSPERBYTE * (int)sizeof(type))
#endif

/* short, regular and long ints with only the high-order bit turned on */
#ifndef HIBITS
#define HIBITS	((short)(1 << (BITS(short) - 1)))
#endif
#ifndef HIBITI
#define HIBITI	(1 << (BITS(int) - 1))
#endif
#ifndef HIBITL
#define HIBITL	(1L << (BITS(long) - 1))
#endif

/* largest short, regular and long int */
#ifndef MAXSHORT
#	define MAXSHORT	((short)~HIBITS)
#endif
#ifndef MAXINT
#	define MAXINT	(~HIBITI)
#endif
#ifndef MAXLONG
#	define MAXLONG	(~HIBITL)
#endif

#if !defined(MAXDOUBLE) || !defined(MAXFLOAT) || !defined(MINDOUBLE) || !defined(MINFLOAT) || !defined(_IEEE) || !defined(_DEXPLEN) || !defined(_HIDDENBIT) || !defined(DMINEXP) || !defined(FMINEXP)
 
/* various values that describe the binary floating-point representation
 * _EXPBASE	- the exponent base
 * DMAXEXP 	- the maximum exponent of a double (as returned by frexp())
 * FMAXEXP 	- the maximum exponent of a float  (as returned by frexp())
 * DMINEXP 	- the minimum exponent of a double (as returned by frexp())
 * FMINEXP 	- the minimum exponent of a float  (as returned by frexp())
 * MAXDOUBLE	- the largest double
			((_EXPBASE ** DMAXEXP) * (1 - (_EXPBASE ** -DSIGNIF)))
 * MAXFLOAT	- the largest float
			((_EXPBASE ** FMAXEXP) * (1 - (_EXPBASE ** -FSIGNIF)))
 * MINDOUBLE	- the smallest double (_EXPBASE ** (DMINEXP - 1))
 * MINFLOAT	- the smallest float (_EXPBASE ** (FMINEXP - 1))
 * DSIGNIF	- the number of significant bits in a double
 * FSIGNIF	- the number of significant bits in a float
 * DMAXPOWTWO	- the largest power of two exactly representable as a double
 * FMAXPOWTWO	- the largest power of two exactly representable as a float
 * _IEEE	- 1 if IEEE standard representation is used
 * _DEXPLEN	- the number of bits for the exponent of a double
 * _FEXPLEN	- the number of bits for the exponent of a float
 * _HIDDENBIT	- 1 if high-significance bit of mantissa is implicit
 * LN_MAXDOUBLE	- the natural log of the largest double  -- log(MAXDOUBLE)
 * LN_MINDOUBLE	- the natural log of the smallest double -- log(MINDOUBLE)
 */
#if u3b || u3b5 || sun
#define MAXDOUBLE	1.79769313486231470e+308
#define MAXFLOAT	((float)3.40282346638528860e+38)
#define MINDOUBLE	4.94065645841246544e-324
#define MINFLOAT	((float)1.40129846432481707e-45)
#define	_IEEE		1
#define _DEXPLEN	11
#define _HIDDENBIT	1
#define DMINEXP	(-(DMAXEXP + DSIGNIF - _HIDDENBIT - 3))
#define FMINEXP	(-(FMAXEXP + FSIGNIF - _HIDDENBIT - 3))
#endif

#ifdef CONFIG_alliant
#define MAXDOUBLE	1.7e+308
#define MINDOUBLE	2.3e-308
#define MAXFLOAT	((float)3.40282346638528860e+38)
#define MINFLOAT	((float)1.40129846432481707e-45)
#define	_IEEE		1
#define _DEXPLEN	11
#define _HIDDENBIT	1
#define DMINEXP	(-(DMAXEXP + DSIGNIF - _HIDDENBIT - 3))
#define FMINEXP	(-(FMAXEXP + FSIGNIF - _HIDDENBIT - 3))
#define LN_MAXFLOAT	8.8722839052068e+01
#define LN_MINFLOAT	-1.03278929903432e+02
#endif

#if pdp11 || vax
#define MAXDOUBLE	1.701411834604692293e+38
#define MAXFLOAT	((float)1.701411733192644299e+38)
/* The following is kludged because the PDP-11 compilers botch the simple form.
   The kludge causes the constant to be computed at run-time on the PDP-11,
   even though it is still "folded" at compile-time on the VAX. */
#define MINDOUBLE	(0.01 * 2.938735877055718770e-37)
#define MINFLOAT	((float)MINDOUBLE)
#define _IEEE		0
#define _DEXPLEN	8
#define _HIDDENBIT	1
#define DMINEXP	(-DMAXEXP)
#define FMINEXP	(-FMAXEXP)
#endif

#if gcos
#define MAXDOUBLE	1.7014118346046923171e+38
#define MAXFLOAT	((float)1.7014118219281863150e+38)
#define MINDOUBLE	2.9387358770557187699e-39
#define MINFLOAT	((float)MINDOUBLE)
#define _IEEE		0
#define _DEXPLEN	8
#define _HIDDENBIT	0
#define DMINEXP	(-(DMAXEXP + 1))
#define FMINEXP	(-(FMAXEXP + 1))
#endif

#ifdef __NeXT__
#define MAXFLOAT ((float)3.4028234663852886e38)
#define MINFLOAT ((float)1.4012984643248171e-45)
#define MAXDOUBLE ((double)1.7976931348623157e308)
#define MINDOUBLE ((double)4.9406564584124654e-324)
#define _IEEE       0		/* probably wrong */
#define _DEXPLEN    8		/* probably wrong */
#define _HIDDENBIT  1		/* probably wrong */
#define DMINEXP     (-DMAXEXP)	/* probably wrong */
#define FMINEXP     (-FMAXEXP)	/* probably wrong */
#endif

#endif

#ifndef _LENBASE
#if u370
#define _LENBASE	4
#else
#define _LENBASE	1
#endif
#endif

#ifndef _EXPBASE
#define _EXPBASE	(1 << _LENBASE)
#endif
#ifndef _FEXPLEN
#define _FEXPLEN	8
#endif
#ifndef DSIGNIF
#define DSIGNIF	(BITS(double) - _DEXPLEN + _HIDDENBIT - 1)
#endif
#ifndef FSIGNIF
#define FSIGNIF	(BITS(float)  - _FEXPLEN + _HIDDENBIT - 1)
#endif
#ifndef DMAXPOWTWO
#define DMAXPOWTWO	((double)(1L << BITS(long) - 2) * \
				(1L << DSIGNIF - BITS(long) + 1))
#endif
#ifndef FMAXPOWTWO
#define FMAXPOWTWO	((float)(1L << FSIGNIF - 1))
#endif
#ifndef DMAXEXP
#define DMAXEXP	((1 << _DEXPLEN - 1) - 1 + _IEEE)
#endif
#ifndef FMAXEXP
#define FMAXEXP	((1 << _FEXPLEN - 1) - 1 + _IEEE)
#endif

#ifndef LN_MAXDOUBLE
#	define LN_MAXDOUBLE	(M_LN2 * DMAXEXP)
#endif
#ifndef LN_MINDOUBLE
#	define LN_MINDOUBLE	(M_LN2 * (DMINEXP - 1))
#endif

#ifndef H_PREC
#define H_PREC	(DSIGNIF % 2 ? (1L << DSIGNIF/2) * M_SQRT2 : 1L << DSIGNIF/2)
#endif
#ifndef X_EPS
#define X_EPS	(1.0/H_PREC)
#endif
#ifndef X_PLOSS
#define X_PLOSS	((double)(long)(M_PI * H_PREC))
#endif
#ifndef X_TLOSS
#define X_TLOSS	(M_PI * DMAXPOWTWO)
#endif

#ifndef M_LN2
#define M_LN2	0.69314718055994530942
#endif
#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif
#ifndef M_SQRT2
#define M_SQRT2	1.41421356237309504880
#endif
#ifndef MAXBEXP
#define MAXBEXP	DMAXEXP /* for backward compatibility */
#endif
#ifndef MINBEXP
#define MINBEXP	DMINEXP /* for backward compatibility */
#endif
#ifndef MAXPOWTWO
#define MAXPOWTWO	DMAXPOWTWO /* for backward compatibility */
#endif

#endif /* _mpeg_values_h */
