/*****************************************************************
|
|      MTVP Player Wrapper Class for win32   
|
|
|      (c) 2000 MpegTV, LLC
|      Author: Tristan Savatier (tristan@mpegtv.com)
|              Gilles Boccon-Gibod (gilles@mpegtv.com)
|
 ****************************************************************/

/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/
#ifndef STRICT
#define STRICT
#endif

#include "mtvp/g2a_api.h"
#include "mtvp_player_win32.hpp"

/*----------------------------------------------------------------------
|       MTVP_Player_win32_message_handler
+---------------------------------------------------------------------*/
LRESULT
MTVP_Player_win32_message_handler(HWND window, 
                     UINT win32_message, 
                     WPARAM win32_wparam, 
                     LPARAM win32_lparam)
{
	MTVP_PMP_HEADER	mtvp_notification_header;
	MTVP_PMP_DATA_A2G	mtvp_notification_data;

    MTVP_Player *mtvp_player = 
        (MTVP_Player *)GetWindowLong(window, GWL_USERDATA);
//    if (player == NULL || win32_message < XA_MSG_BASE) {
    if (!mtvp_player) {
        return DefWindowProc(window, win32_message, win32_wparam, win32_lparam);
    }
    
	if (mtvp_translate_msg(mtvp_player->player,
							win32_message, 
							win32_wparam, 
							win32_lparam, 
							&mtvp_notification_header,
							&mtvp_notification_data) == 0) {
        mtvp_player->MtvpHandleNotificationMessage(&mtvp_notification_header, &mtvp_notification_data);
        return 0;
    } else {
        return DefWindowProc(window, win32_message, win32_wparam, win32_lparam);
    }
}


// eof
