// PocketTV
//

#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"
#include "pockettv.hpp"
#include "registry.h"
#include "utils.h"
//#include "voh_gapi_api.h"
#include "casio-oemdrvescape.h"

#include <commctrl.h>
#include <commdlg.h>
#include <winnls.h>
#include <shlobj.h>
#ifdef HAVE_AYGSHELL
#include <aygshell.h>
#endif

// WM_NCACTIVATE seems to be missing from the POCKET_PC header files
#ifndef WM_NCACTIVATE
#define WM_NCACTIVATE 0x86
#endif

////////////////////////// SHGetMenu Macro's
#ifdef POCKET_PC //Rapier devices

//Menu Bar Height
#define MENU_HEIGHT 26

#define SHGetMenu(hWndMB)  (HMENU)SendMessage((hWndMB), SHCMBM_GETMENU, (WPARAM)0, (LPARAM)0);
#define SHGetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);
#define SHSetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_SETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);

//Alternate definition
#define SHMenuBar_GetMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);


#else //non-Rapier devices

#define MENU_HEIGHT 0

#define SHGetMenu(hWndCB) (HMENU)CommandBar_GetMenu(hWndCB, 0)
#define SHGetSubMenu(hWndCB,ID_MENU) (HMENU)GetSubMenu((HMENU)CommandBar_GetMenu(hWndCB, 0), ID_MENU)
#define SHSetSubMenu(hWndMB,ID_MENU)


#endif

#include <stdlib.h>

#include "files.h"

#define SEEK_SLIDER_SETSEL


#define IDM_OPTIONS_AUDIO_QUALITY_FIRST Min(IDM_OPTIONS_AUDIO_QUALITY_HIGH, Min(IDM_OPTIONS_AUDIO_QUALITY_LOW, IDM_OPTIONS_AUDIO_QUALITY_MEDIUM))
#define IDM_OPTIONS_AUDIO_QUALITY_LAST Max(IDM_OPTIONS_AUDIO_QUALITY_HIGH, Max(IDM_OPTIONS_AUDIO_QUALITY_LOW, IDM_OPTIONS_AUDIO_QUALITY_MEDIUM))
#define IDM_OPTIONS_AUDIO_CHANNEL_FIRST Min(IDM_OPTIONS_AUDIO_CHANNEL_BOTH, Min(IDM_OPTIONS_AUDIO_CHANNEL_LEFT, IDM_OPTIONS_AUDIO_CHANNEL_RIGHT))
#define IDM_OPTIONS_AUDIO_CHANNEL_LAST Max(IDM_OPTIONS_AUDIO_CHANNEL_BOTH, Max(IDM_OPTIONS_AUDIO_CHANNEL_LEFT, IDM_OPTIONS_AUDIO_CHANNEL_RIGHT))
//#define IDM_OPTIONS_VIDEO_STRETCH_FIRST Min(IDM_OPTIONS_VIDEO_STRETCH_FILL, Min(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Min(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS)))
//#define IDM_OPTIONS_VIDEO_STRETCH_LAST Max(IDM_OPTIONS_VIDEO_STRETCH_FILL, Max(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Max(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS)))
#define IDM_OPTIONS_VIDEO_STRETCH_FIRST Min(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Min(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS))
#define IDM_OPTIONS_VIDEO_STRETCH_LAST Max(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Max(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS))

#define IDM_OPTIONS_VOLUME_RANGE_FIRST Min(IDM_OPTIONS_VOLUME_RANGE_HALF, IDM_OPTIONS_VOLUME_RANGE_FULL)
#define IDM_OPTIONS_VOLUME_RANGE_LAST Max(IDM_OPTIONS_VOLUME_RANGE_HALF, IDM_OPTIONS_VOLUME_RANGE_FULL)

//#define IDM_OPTIONS_RATE_FACTOR_FIRST Min(IDM_OPTIONS_RATE_FACTOR_1_8, Min(IDM_OPTIONS_RATE_FACTOR_1_4, Min(IDM_OPTIONS_RATE_FACTOR_1_2, Min(IDM_OPTIONS_RATE_FACTOR_X_2, Min(IDM_OPTIONS_RATE_FACTOR_X_4, IDM_OPTIONS_RATE_FACTOR_X_8)))))
//#define IDM_OPTIONS_RATE_FACTOR_LAST Max(IDM_OPTIONS_RATE_FACTOR_1_8, Max(IDM_OPTIONS_RATE_FACTOR_1_4, Max(IDM_OPTIONS_RATE_FACTOR_1_2, Max(IDM_OPTIONS_RATE_FACTOR_X_2, Max(IDM_OPTIONS_RATE_FACTOR_X_4, IDM_OPTIONS_RATE_FACTOR_X_8)))))

#define TIMER_POSITION_INTERVAL		1000	// to update seek slider position while playing
#define TIMER_FRAMERATE_INTERVAL	5000	// to update framerate while playing
#define TIMER_KEEPALIVE_INTERVAL	55000	// to prevent auto-shutdown while playing. must be less than 1 minute (minimum setting for auto-shutdown)!
#define TIMER_KEEPBRIGHT_INTERVAL	7000	// to prevent auto-dim while playing. must be less than 10 sec (minimum setting for auto-dim on the jornada 540)!
#define TIMER_CANCELMODE_INTERVAL	100

#define VOLUME_SLIDER_MAX			10
#define TRACK_SLIDER_MAX			10000
#define FAST_FORWARD_COEF			8.0

#define SEEK_SLIDER_HEIGHT 22

#define FULLSCREEN_WINDOW_CLASS_NAME	TEXT("MpegTV VOH GAPI")

//#define SuspendVideo()	SuspendVideo0(__LINE__)
//#define ResumeVideo()	ResumeVideo0(__LINE__)

/*--------------------------------------------------------------------------+
| Globals
+--------------------------------------------------------------------------*/
#ifndef NO_GLOBALS
PocketTV *Player;
#endif



/*----------------------------------------------------------------------
|       PocketTVWindowProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK
PocketTVWindowProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
#ifdef NO_GLOBALS
	POCKETTV_HANDLE_WINDOW_MESSAGE(PocketTV, 
                             HandleWindowsMessage,
                             window, 
                             message, 
                             wparam, 
                             lparam);

#else

	PocketTV *target = Player;
    if (target) {
        return target->HandleWindowsMessage(window,
		                           message,
		 	    				   wparam,
								   lparam);
	} else {
		return DefWindowProc(window, message, wparam, lparam);
	}

#endif
}

/*----------------------------------------------------------------------
| center_dialog
+---------------------------------------------------------------------*/
static void
center_dialog(HWND hDlg) {
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	// trying to center the dialog window

	// bug: this does not take the SIP into account:
	// if the SIP is visible, the window is NOT properly centered...

	if (GetWindowRect(hDlg, &rt1)) {
		GetClientRect(GetParent(hDlg), &rt);
		DlgWidth	= rt1.right - rt1.left;
		DlgHeight	= rt1.bottom - rt1.top ;
		NewPosX		= (rt.right - rt.left - DlgWidth)/2;
		NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
		
		// if the About box is larger than the physical screen 
		if (NewPosX < 0) NewPosX = 0;
		if (NewPosY < 0) NewPosY = 0;
		SetWindowPos(hDlg, 0, NewPosX, NewPosY,
			0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
}


/*--------------------------------------------------------------------------+
| DialogAboutEasterEgg
+--------------------------------------------------------------------------*/
void
PocketTV::DialogAboutEasterEgg(HWND hWnd)
{
	ErrorBox(hWnd, IDS_WINDOW_CAPTION_MESSAGE, TEXT("Credits:\n\nTristan Savatier\nGilles Boccon-Gibod"));
	if (!m_Registered) {
		RegDeleteKey(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"));
//		DestroyWindow(m_Window);
		ExitThread(0);
	}
}

extern "C" {
extern int SetNavBarText(HWND hWnd, const TCHAR *str);
}

/*----------------------------------------------------------------------
| DialogAbout
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
DialogAbout(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	// Mesage handler for the About box.

	switch (message)
	{
		case WM_INITDIALOG:
#ifdef POCKET_PC
			{
				SHINITDLGINFO shidi;
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON|SHIDIF_FULLSCREENNOMENUBAR;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
			}
#else
			center_dialog(hDlg);
#endif
			{
				TCHAR buf[128];

				swprintf(buf, TEXT("Version %d.%d.%d / mtvp-sdk %d.%d.%d"),
								POCKETTV_VERSION_MAJOR, POCKETTV_VERSION_MINOR, POCKETTV_VERSION_REVISION,
								MTVP_VERSION_MAJOR, MTVP_VERSION_MINOR, MTVP_VERSION_REVISION);

				SendMessage(GetDlgItem(hDlg, IDC_STATIC_ABOUT_VERSION), WM_SETTEXT, 0, (LPARAM)buf);
			}

			SetNavBarText(hDlg, NULL);

			return TRUE;

		case WM_SETFOCUS:
			SHFullScreen(hDlg, SHFS_HIDESIPBUTTON);
			return TRUE;

//		case WM_KILLFOCUS:
//			SetNavBarText((HWND)wParam, NULL);
//			return TRUE;

		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			switch (wmId) {
				case IDCANCEL:
				case IDOK:
					EndDialog(hDlg, wmId);
					break;
				case ID_STATIC_ABOUT_ICON:
					{
#ifdef NO_GLOBALS
						PocketTV *player = (PocketTV *)GetWindowLong(GetParent(window), GWL_USERDATA);
#else
						PocketTV *player = Player;
#endif
						player->DialogAboutEasterEgg(hDlg);
					}
					break;
			}
			return TRUE;
	}
    return FALSE;
}


#ifdef POCKET_PC
/*----------------------------------------------------------------------
| CreateMenuBar
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateMenuBar(HWND hWnd, int nToolBarId, int dwFlags)
{
	SHMENUBARINFO mbi = {0};

	mbi.cbSize = sizeof (SHMENUBARINFO);
	mbi.hInstRes = m_Instance;
	mbi.hwndParent = hWnd;
	mbi.nToolBarId = nToolBarId;
	mbi.nBmpId = 0;
	mbi.cBmpImages = 0;
	mbi.dwFlags = dwFlags;
	if (!SHCreateMenuBar(&mbi)) {
		ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create menu bar"));
		return NULL;
	}
	return mbi.hwndMB;
}
#endif


/*--------------------------------------------------------------------------+
| ErrorBoxEx
+--------------------------------------------------------------------------*/
void
PocketTV::ErrorBoxEx(HWND window, int ids_window_caption_error, const TCHAR *format, const va_list *args)
{
	TCHAR	buffer[512];
	const TCHAR *title = MyLoadString(m_Instance, ids_window_caption_error);

	if (format == NULL) {
		format = TEXT("not enough memory to load message!");
	}

#ifdef POCKET_PC
	_vsnwprintf(buffer, sizeofarray(buffer) - 1, format, *args);
#else
	vswprintf(buffer, format, *args);
#endif

	buffer[sizeofarray(buffer) - 1] = 0;

	MessageBox(window, buffer, title, MB_OK | MB_TOPMOST | MB_APPLMODAL | MB_SETFOREGROUND);
	MyFreeString(title);
}


/*--------------------------------------------------------------------------+
| ErrorBox
+--------------------------------------------------------------------------*/
void
PocketTV::ErrorBox(HWND window, int ids_window_caption_error, const TCHAR *format, ...)
{
	va_list	args;

#ifdef USE_FULLSCREEN
	if (m_PlayFullscreen) {
		SetState(MTVP_STATE_PAUSED);
	}
	Fullscreen(false);
#endif

	va_start(args, format);
	ErrorBoxEx(window, ids_window_caption_error, format, &args);
	va_end(args);
}


/*--------------------------------------------------------------------------+
| get_msg_error_string
+--------------------------------------------------------------------------*/
TCHAR *
get_msg_error_string(int status)
{
	LPTSTR lpMsgBuf = NULL;
	USES_CONVERSION;
	int	ret;

	// returns a malloc'ed buffer containing error message, or NULL.
	// caller must free the buffer returned by this routine, if not NULL.

	if (status > 0) {
		ret = FormatMessage(  
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			status,
//			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL);
//		if (!ret) {
//			ret = GetLastError();
//		}
		return lpMsgBuf;
	} else {
		return _wcsdup(A2W(msg_error_string(status)));
	}
}


/*----------------------------------------------------------------------
| DialogOpenURL
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
DialogOpenURL(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
#ifdef NO_GLOBALS
	PocketTV *player = (PocketTV *)GetWindowLong(GetParent(hDlg), GWL_USERDATA);
#else
	PocketTV *player = Player;
#endif

	switch (message)
	{
		case WM_INITDIALOG:
			ShowSip();
#ifdef POCKET_PC
			player->CreateMenuBar(hDlg, IDM_EMPTY, 0);
			{
				SHINITDLGINFO shidi;
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON|SHIDIF_SIZEDLGFULLSCREEN;
				   
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
			}
#else
			center_dialog(hDlg);
#endif
			{
				unsigned int	n;
				const TCHAR	*url;

				url = player->m_URLName ? player->m_URLName : TEXT("http://");
				SetDlgItemText(hDlg, IDC_EDIT_URL, url);
				n = wcslen(url);
				SendMessage(GetDlgItem(hDlg, IDC_EDIT_URL), EM_SETSEL, n, n);
			}
			SetFocus(GetDlgItem(hDlg, IDC_EDIT_URL));
			SetNavBarText(hDlg, NULL);
			return FALSE;

//		case WM_KILLFOCUS:
//			SetNavBarText((HWND)wParam, NULL);
//			return TRUE;

		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			switch (wmId) {
				case IDOK: 
				case IDCANCEL: 
					EndDialog(hDlg, LOWORD(wParam));
//					HideSip();
					break;
				case IDC_OPEN_URL:
					{
					TCHAR url[256];
					int status;
					
					url[sizeofarray(url) - 1] = 0;
					if (GetDlgItemText(
							hDlg,       // handle of dialog box
							IDC_EDIT_URL,  // identifier of control
							url, // address of buffer for text
							sizeofarray(url) - 1    // maximum size of string
							) != 0) {

						if (player->m_URLName != NULL) free((void *)player->m_URLName);
						player->m_URLName = _wcsdup(url);
						if ((status = player->OpenURL(player->m_URLName)) == 0) {
							EndDialog(hDlg, LOWORD(wParam));
//							HideSip();
						} else {
							TCHAR *p = get_msg_error_string(status);
							const TCHAR *msg = MyLoadString(player->m_Instance, IDS_MESSAGE_OPEN_ERROR);
							player->ErrorBox(hDlg, IDS_WINDOW_CAPTION_ERROR,
									msg, url, p ? p : L"", status);
							if (p) free(p);
							MyFreeString(msg);
						}
					}
					}
					break;
			}
			return TRUE;
	}
    return FALSE;
}


/*----------------------------------------------------------------------
| OpenURL
+---------------------------------------------------------------------*/
int
PocketTV::OpenURL(const TCHAR *url)
{
	int		status;
	void	*value;
	USES_CONVERSION;

	KeepBright();	// must call that here, because OpenURL can take a while!

	CloseStream();

	MtvpSetSynchronousMode();
	MtvpOpenStreamURL(W2A(url));
	if (MtvpGetCommandStatus(&status, &value) == 0) {
		if (status != 0) {
			const TCHAR *p = get_msg_error_string(status);
			const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_OPEN_ERROR);
			ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, url, p ? p : L"", status);
			if (p) free((void *)p);
			MyFreeString(msg);

			return status;
		} else {
			unsigned int		url_length;

			m_StreamOpened = true;

			_msg_printf("%s was opened by SIH header-id = %d\n", url, (int)value);

			ActivateStreamControls();

			if (m_StreamName == NULL) free(m_StreamName);
			url_length = wcslen(url);
			m_StreamName = (TCHAR *)malloc((url_length + 3) * sizeof(TCHAR));

			if (m_StreamName) {
				// start with two tabs to have right-aligned text
				m_StreamName[0] = L'\t';
				m_StreamName[1] = L'\t';
				wcsncpy(&m_StreamName[2], url, url_length);
				m_StreamName[url_length + 2] = 0;
			}
#ifndef POCKET_PC
			if (m_ShowStatusBar) {
				InvalidateRect(m_Window, &m_StreamNameRect, TRUE);
			}
#endif
			// reset a few variables to start on a good foot...
			m_PendingSeek = -1;
//			m_DisplayReady = false;	// set a few lines further
			m_LastPositionTimerTime = 0;

			{
				const TCHAR *title = wcsrchr(url, L'\\');
				const TCHAR ext[] = TEXT(".mpg");
				const TCHAR appname[] = TEXT("PocketTV ");
				unsigned int trailing;
				unsigned int n;

				if (m_NavBarTitle) {
					free(m_NavBarTitle);
				}

				if (title) {
					title++;
				} else {
					title = url;
				}
				n = wcslen(title);
				if (n > sizeofarray(ext) && _wcsicmp(title + n - sizeofarray(ext) + 1, ext) == 0) {
					trailing = sizeofarray(ext) - 1;
				} else {
					trailing = 0;
				}
				m_NavBarTitle = (TCHAR *)malloc(sizeof(TCHAR) * (sizeofarray(appname) - 1 + n - trailing + 1));
				if (m_NavBarTitle) {
					memcpy((void *)m_NavBarTitle, appname, sizeof(TCHAR) * (sizeofarray(appname) - 1));
					memcpy((void *)(m_NavBarTitle + sizeofarray(appname) - 1), title, sizeof(TCHAR) * (n - trailing));
					m_NavBarTitle[sizeofarray(appname) - 1 + n - trailing] = 0;
				}
				m_NavBarTitle[sizeofarray(appname) - 1] = towupper(m_NavBarTitle[sizeofarray(appname) - 1]);
			}

			// in this case it's probably a good idea to reset the rate factor
			MtvpSetRateFactor(1.0);
			m_FastForward = false;

			m_DisplayReady = true;	// assume display is ready to avoid 'double seek'
			// otherwise this seek(0) would occur when display becomes ready.
			MySeek(0);	// this should immediately reset the seek slider to 0

			if (m_AutoPlay) {
				SetState(MTVP_STATE_PLAYING);
			} else {
				SetState(MTVP_STATE_PAUSED);
			}
			// make sure that m_NavBarTitle is set before calling ReflectState()!
			ReflectState();

			SetNavBarText(m_Window, m_NavBarTitle);

			return 0;
		}
	} else {
		abort();	// last command did not have MTVP_PMP_FLAG_SYNCHRONOUS!
		return -1;
	}
}

#if 0
/*----------------------------------------------------------------------
| RateFactor
+---------------------------------------------------------------------*/
void
PocketTV::RateFactor(int rate_factor)
{
	unsigned int wmId;

	switch (rate_factor) {
		case -8:		wmId = IDM_OPTIONS_RATE_FACTOR_1_8; break;
		case -4:		wmId = IDM_OPTIONS_RATE_FACTOR_1_4; break;
		case -2:		wmId = IDM_OPTIONS_RATE_FACTOR_1_2; break;
		case 2:			wmId = IDM_OPTIONS_RATE_FACTOR_X_2; break;
		case 4:			wmId = IDM_OPTIONS_RATE_FACTOR_X_4; break;
		case 8:			wmId = IDM_OPTIONS_RATE_FACTOR_X_8; break;
		default:		wmId = IDM_OPTIONS_RATE_FACTOR_X_8; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_RATE_FACTOR_FIRST,
						  IDM_OPTIONS_RATE_FACTOR_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	SetRegistryValueDWORD(TEXT("RateFactor"), rate_factor);
	if (rate_factor >= 0) {
		m_RateFactor = rate_factor;
	} else {
		m_RateFactor = 1.0 / -rate_factor;
	}
}

/*----------------------------------------------------------------------
| SetRateFactor
+---------------------------------------------------------------------*/
void
PocketTV::SetRateFactor(int rate_factor)
{
	RateFactor(rate_factor);
	SendMessage(m_Window, WM_COMMAND, IDM_CONTROLS_FFW, 0);
}
#endif // 0

/*----------------------------------------------------------------------
| SetMute
+---------------------------------------------------------------------*/
void
PocketTV::SetMute(bool yes)
{
	MtvpMute(yes);
	SendMessage(GetDlgItem(m_VolumeDialog, IDC_MUTE), BM_SETCHECK, yes ? BST_CHECKED : BST_UNCHECKED, 0);
	SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(yes ? 15+5 : 15+4, 0));
	m_Muted = yes;
}

/*----------------------------------------------------------------------
| SetAudioChannel
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioChannel(MTVP_AUDIO_CHANNEL channel)
{
	unsigned int wmId;

	MtvpSetAudioChannel(channel);
	SetRegistryValueDWORD(TEXT("AudioChannel"), channel);
	switch (channel) {
		case MTVP_AUDIO_CHANNEL_BOTH:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_BOTH; break;
		case MTVP_AUDIO_CHANNEL_LEFT:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_LEFT; break;
		case MTVP_AUDIO_CHANNEL_RIGHT:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_RIGHT; break;
		default:						wmId = 0; break;
	}
	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_AUDIO_CHANNEL_FIRST,
							  IDM_OPTIONS_AUDIO_CHANNEL_LAST,   
							  wmId,
							  MF_BYCOMMAND);
}

/*----------------------------------------------------------------------
| SetAudioQuality
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioQuality(MTVP_AUDIO_QUALITY quality)
{
	unsigned int wmId;

	MtvpSetAudioQuality(quality);
	SetRegistryValueDWORD(TEXT("AudioQuality"), quality);

	switch (quality) {
		case MTVP_AUDIO_QUALITY_LOW:	wmId = IDM_OPTIONS_AUDIO_QUALITY_LOW; break;
		case MTVP_AUDIO_QUALITY_MEDIUM:	wmId = IDM_OPTIONS_AUDIO_QUALITY_MEDIUM; break;
		case MTVP_AUDIO_QUALITY_HIGH:	wmId = IDM_OPTIONS_AUDIO_QUALITY_HIGH; break;
		default:						wmId = 0; break;
	}
	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_AUDIO_QUALITY_FIRST,
							  IDM_OPTIONS_AUDIO_QUALITY_LAST,   
							  wmId,
							  MF_BYCOMMAND);
}

/*----------------------------------------------------------------------
| Loop
+---------------------------------------------------------------------*/
void
PocketTV::Loop(bool yes)
{
	MtvpLoop(yes);
	SetRegistryValueDWORD(TEXT("Loop"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_LOOP, (yes ? MF_CHECKED : MF_UNCHECKED));
}

/*----------------------------------------------------------------------
| AutoPlay
+---------------------------------------------------------------------*/
void
PocketTV::AutoPlay(bool yes)
{
//	MtvpAutoPlay(yes);
	SetRegistryValueDWORD(TEXT("AutoPlay"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_AUTO_PLAY, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_AutoPlay = yes;
}

/*----------------------------------------------------------------------
| EnableDither
+---------------------------------------------------------------------*/
int
PocketTV::EnableDither(VOH_WIN32_STRETCH stretch)
{
	int		status;
	void	*value;
	int dither_spec;

	if (m_Dither != MTVP_DITHER_SPEC_NONE && (m_FastVideo
				|| stretch == VOH_WIN32_STRETCH_NEVER
				|| (stretch == VOH_WIN32_STRETCH_AUTO && m_VideoInfos.width != 0
					&& (int)m_VideoInfos.width < m_TargetRect.right - m_TargetRect.left))) {
		dither_spec = m_Dither;
	} else {
		dither_spec = MTVP_DITHER_SPEC_NONE;
	}
	MtvpSetSynchronousMode();
	MtvpDitherSpec(dither_spec);
	MtvpGetCommandStatus(&status, &value);
	
	return status;
}

/*----------------------------------------------------------------------
| DitherType
+---------------------------------------------------------------------*/
void
PocketTV::DitherType(int dither)
{
	SetRegistryValueDWORD(TEXT("DitherType"), dither);
	m_DitherType = dither;
}

/*----------------------------------------------------------------------
| Dither
+---------------------------------------------------------------------*/
int
PocketTV::Dither(bool yes)
{
	SetRegistryValueDWORD(TEXT("Dither"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_DITHER, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_Dither = yes;

	return EnableDither(m_Stretch);
}

/*----------------------------------------------------------------------
| SetDither
+---------------------------------------------------------------------*/
void
PocketTV::SetDither(bool yes)
{
	Dither(yes);
	if (m_State != MTVP_STATE_PLAYING) {
		MtvpRepaint();
	}
}

/*----------------------------------------------------------------------
| ShowStatusBar
+---------------------------------------------------------------------*/
void
PocketTV::ShowStatusBar(bool yes)
{
	SetRegistryValueDWORD(TEXT("StatusBar"), yes);
	m_ShowStatusBar = yes;
#ifndef POCKET_PC
	InvalidateRect(m_Window, &m_StreamNameRect, TRUE);
#endif
	ShowWindow(m_StatusWindow, m_ShowStatusBar ? SW_SHOW : SW_HIDE);
	UpdateVideoTargetRect();
	CheckMenuItem(m_Menu, IDM_OPTIONS_SHOW_STATUS_WINDOW, (m_ShowStatusBar ? MF_CHECKED : MF_UNCHECKED));
}


#ifdef USE_FULLSCREEN
/*----------------------------------------------------------------------
| PlayFullscreen
+---------------------------------------------------------------------*/
void
PocketTV::PlayFullscreen(bool yes)
{
//	MtvpAutoPlay(yes);
	SetRegistryValueDWORD(TEXT("PlayFullscreen"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_PLAY_FULLSCREEN, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_PlayFullscreen = yes;
}

/*----------------------------------------------------------------------
| Fullscreen
+---------------------------------------------------------------------*/
void
PocketTV::Fullscreen(bool yes)
{
	bool	was_fullscreen = m_Fullscreen;
	MTVP_STATE	was_in_state = m_State;

	if (m_Fullscreen == yes) {
		return;
	}

	if (m_CancelModePending) {
		ResumeVideo();
		m_CancelModePending = false;
	}

	m_DisableResumeVideo = true;

	if (yes && m_VOHHandlerId == MTVP_VOH_HANDLER_ID_WIN32) {
		SuspendVideo();
		m_Fullscreen = yes;
		Gapi0(true, true);
	} else {
		m_Fullscreen = yes;
	}

	if (was_fullscreen) {
		SuspendVideo();
		ShowWindow(m_FullscreenWindow, SW_HIDE);
	}

	GapiSetVideoTargetRect();
	
	if (m_Fullscreen) {
		ShowWindow(m_FullscreenWindow, SW_SHOW);
		SetForegroundWindow(m_FullscreenWindow);
	} else {
		SetForegroundWindow(m_Window);
	}

	if (!yes) {
		if (!m_FastVideo) {
			Gapi0(false, true);
		}
	}
	m_DisableResumeVideo = false;
	ResumeVideo();
}

/*----------------------------------------------------------------------
| FullscreenKillFocus
+---------------------------------------------------------------------*/
void
PocketTV::FullscreenKillFocus()
{
	if (m_Fullscreen) {
		m_WasPlayingBeforeBecommingInactive = (m_State == MTVP_STATE_PLAYING);
		SetState(MTVP_STATE_PAUSED);
//				player->Gapi0(false, true);
//				player->Fullscreen(false);
//				player->m_FullscreenActive = false;
	}
}

/*----------------------------------------------------------------------
| FullscreenSetFocus
+---------------------------------------------------------------------*/
void
PocketTV::FullscreenSetFocus()
{
	SHFullScreen(m_FullscreenWindow, SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
}

/*----------------------------------------------------------------------
| fullscreen_window_proc
+---------------------------------------------------------------------*/
static LRESULT CALLBACK 
fullscreen_window_proc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#ifdef NO_GLOBALS
    PocketTV *player = (PocketTV *)GetWindowLong(hWnd, GWL_USERDATA);
#else
	PocketTV *player = Player;
#endif

	switch (message)
	{
		case WM_PAINT:
			{
				HDC hdc;
				PAINTSTRUCT ps;
				hdc = BeginPaint(hWnd, &ps);
				EndPaint(hWnd, &ps);
				player->MtvpRepaint();
			}
			break;
//		case WM_ACTIVATE:
//			if (LOWORD(wParam) == WA_INACTIVE) {
//				player->SetState(MTVP_STATE_PAUSED);
//				player->Gapi0(false, true);
//			}
//			break;
		case WM_KILLFOCUS:
			player->FullscreenKillFocus();
			break;
		case WM_SETFOCUS:
			player->FullscreenSetFocus();
			break;
		case WM_LBUTTONDOWN:
//			player->m_FullscreenActive = false;
			player->Fullscreen(false);
			break;
//		case WM_DESTROY:
//			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
#endif // USE_FULLSCREEN

/*----------------------------------------------------------------------
| GapiInit
+---------------------------------------------------------------------*/
int
PocketTV::GapiInit()
{
	int		status;
	void	*value;


#ifdef USE_FULLSCREEN
	WNDCLASS	wc;

	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE;
	wc.lpfnWndProc		= (WNDPROC) fullscreen_window_proc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= m_Instance;
	wc.hIcon			= (HICON)NULL;
	wc.hCursor			= 0;
	wc.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName		= 0;
	wc.lpszClassName	= FULLSCREEN_WINDOW_CLASS_NAME;

	RegisterClass(&wc);

	m_FullscreenWindow = CreateWindow(FULLSCREEN_WINDOW_CLASS_NAME, TEXT(""), WS_POPUP,
		0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
		(HWND)NULL, (HMENU)NULL, m_Instance, NULL);
#ifdef NO_GLOBALS
	SetWindowLong(m_FullscreenWindow, GWL_USERDATA, (LONG)this);
#endif

#endif // USE_FULLSCREEN

	MTVP_VOH_GAPI_INIT_OUTPUT result;
	MTVP_VOH_GAPI_INIT data;

	data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
	data.instance = m_Instance;
	data.window = m_Window;
	data.result = &result;

	MtvpSetSynchronousMode();
	MtvpSendCommandCustom(MTVP_COMMAND_VOH_INIT, (const void *)&data, sizeof data);
	MtvpGetCommandStatus(&status, &value);

	if (status != 0) {
		_msg_printf("GapiInit: error %d\n", status);
	} else {

		m_GapiExchangeXY = data.result->exchange_x_y;
	}

	return status;
}

/*--------------------------------------------------------------------------+
| GapiSetVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::GapiSetVideoTargetRect() 
{
	RECT rect_absolute;
	int		status;
	void	*value;

#ifdef USE_FULLSCREEN
	if (m_Fullscreen) {
		rect_absolute.top = 0;
		rect_absolute.left = 0;
		rect_absolute.bottom = GetSystemMetrics(SM_CYSCREEN);
		rect_absolute.right = GetSystemMetrics(SM_CXSCREEN);
	} else 
#endif
			{
		rect_absolute = m_TargetRect;
		rect_absolute.top += MENU_HEIGHT;
		rect_absolute.bottom += MENU_HEIGHT;
	}
	if (m_GapiExchangeXY) {
		RECT r = rect_absolute;

		rect_absolute.top = r.left;
		rect_absolute.left = r.top;
		rect_absolute.bottom = r.right;
		rect_absolute.right = r.bottom;
	}

	MTVP_VOH_GAPI_CNTL data;

	data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
	data.type = MTVP_VOH_GAPI_CNTL_TYPE_TARGET;
#ifdef USE_FULLSCREEN
	if (m_Fullscreen) {
		data.data.target.window = m_FullscreenWindow;
	} else 
#endif
			{
		data.data.target.window = m_Window;
	}
	data.data.target.rect = rect_absolute;

	MtvpSetSynchronousMode();
	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
	MtvpGetCommandStatus(&status, &value);
}

/*----------------------------------------------------------------------
| Gapi0
+---------------------------------------------------------------------*/
bool
PocketTV::Gapi0(bool yes, bool sync)
{
//	_msg_printf("Gapi0 %d %d\n", yes, (int)sync);

	if ((yes && m_VOHHandlerId != MTVP_VOH_HANDLER_ID_WIN32)
		|| (!yes && m_VOHHandlerId == MTVP_VOH_HANDLER_ID_WIN32)) {
//		_msg_printf("Gapi0 does nothing\n");
		return yes;
	}

	m_LastPositionTimerTime = 0;

	if (yes) {
		int		status;
		void	*value;

		SetVideoStretch0(VOH_WIN32_STRETCH_NEVER);

//		m_Fullscreen = true; // test fullscreen


		if (sync) {
			MtvpSetSynchronousMode();
			MtvpSelectVOH(MTVP_VOH_HANDLER_ID_GAPI);
			MtvpGetCommandStatus(&status, &value);
			if (status != 0) {
//				_msg_printf("Gapi: error %d, %s\n", status, msg_error_string(status));

				const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_GAPI_ERROR);
				ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, status);
				MyFreeString(msg);
				yes = false;
			}
		} else {
			MtvpSelectVOH(MTVP_VOH_HANDLER_ID_GAPI);
		}
	}
	if (yes) {
//		CalculateVideoTargetRect();

		m_VOHHandlerId = MTVP_VOH_HANDLER_ID_GAPI;

		GapiSetVideoTargetRect();

//		SHDoneButton(m_Window, SHDB_HIDE);
	} else {

		// assume that MTVP_VOH_HANDLER_ID_WIN32 is always available!
		MtvpSelectVOH(MTVP_VOH_HANDLER_ID_WIN32);
		SetVideoStretch0(m_Stretch);

		m_VOHHandlerId = MTVP_VOH_HANDLER_ID_WIN32;

//		SHDoneButton(m_Window, SHDB_SHOW);

//		m_Fullscreen = false; // test fullscreen

	}
//	_msg_printf("Gapi0 returns %d\n", yes);
	return yes;
}

/*----------------------------------------------------------------------
| Gapi
+---------------------------------------------------------------------*/
void
PocketTV::Gapi(bool yes)
{
//	_msg_printf("Gapi %d\n", yes);

	if ((yes && m_FastVideo)
		|| (!yes && !m_FastVideo)) {
//		_msg_printf("Gapi does nothing\n", yes);
		return;
	}
	SuspendVideo();
	yes = Gapi0(yes, true);
	ResumeVideo();

//	_msg_printf("in Gapi, Gapi0 returned %d\n", yes);

	m_FastVideo = yes;

	SetRegistryValueDWORD(TEXT("FastVideo"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_FAST_VIDEO, (yes ? MF_CHECKED : MF_UNCHECKED));
	if (yes) {
//		ResumeVideo();
	} else {
//		SetVideoStretch(m_Stretch);
	}
}

/*----------------------------------------------------------------------
| SuspendVideo
+---------------------------------------------------------------------*/
int
//PocketTV::SuspendVideo0(unsigned int n)
PocketTV::SuspendVideo()
{
	int		status;
	void	*value;

//	_msg_printf("SuspendVideo %d\n", n);

	MtvpSetSynchronousMode();
	MtvpSuspendVideo();
	MtvpGetCommandStatus(&status, &value);

	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		MTVP_VOH_GAPI_CNTL data;
		data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
		data.type = MTVP_VOH_GAPI_CNTL_TYPE_SUSPEND;

		MtvpSetSynchronousMode();
		MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
		MtvpGetCommandStatus(&status, &value);
		if (status != 0) {
//			_msg_printf("SuspendVideo: error %d, %s\n", status, msg_error_string(status));
		}
	}

//	if (m_Fullscreen) {
//		ShowWindow(m_FullscreenWindow, SW_HIDE);
//	}

//	_msg_printf("SuspendVideo status %d\n", status);

	return status;
}

/*----------------------------------------------------------------------
| ResumeVideo
+---------------------------------------------------------------------*/
int
//PocketTV::ResumeVideo0(unsigned int n)
PocketTV::ResumeVideo()
{
	int		status = 0;
	void	*value;

//	_msg_printf("ResumeVideo %d\n", n);
//	_msg_printf("ResumeVideo\n");

	if (m_DisableResumeVideo) {
		return 0;
	}

//	Gapi0(true, false);

//	if (m_Fullscreen) {
//		ShowWindow(m_FullscreenWindow, SW_SHOW);
//		SetForegroundWindow(m_FullscreenWindow);
//		SHFullScreen(m_FullscreenWindow, SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
//	}

	MtvpResumeVideo();

	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		MTVP_VOH_GAPI_CNTL data;
		data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
		data.type = MTVP_VOH_GAPI_CNTL_TYPE_RESUME;

		MtvpSetSynchronousMode();
		MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
		MtvpGetCommandStatus(&status, &value);

		if (status != 0) {
	//		_msg_printf("ResumeVideo: error %d, %s\n", status, msg_error_string(status));
		}
	}

	return status;
}

/*----------------------------------------------------------------------
| SetState
+---------------------------------------------------------------------*/
void
PocketTV::SetState(MTVP_STATE state)
{
	int		status;
	void	*value;

//	_msg_printf("SetState %d\n", state);
	if (state == MTVP_STATE_PLAYING) {
		if (m_CancelModePending) {
			ResumeVideo();
			m_CancelModePending = false;
		}
#ifdef USE_FULLSCREEN
		if (m_PlayFullscreen) {
			Fullscreen(true);
		}
#endif
	}

	m_State = state;

	ReflectState();

	if (m_FastVideo && state == MTVP_STATE_PLAYING) {
		bool yes;

		if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
			ResumeVideo();
		} else {
			SuspendVideo();
			yes = Gapi0(true, true);
			ResumeVideo();
			if (yes) {
//				ResumeVideo();
			} else {
				Gapi(false);
			}
		}
	}

	if (m_FastVideo && state == MTVP_STATE_PAUSED) {
		MtvpSetSynchronousMode();
		MtvpSetState(state);
		MtvpGetCommandStatus(&status, &value);
	} else {
		MtvpSetState(state);
	}

//	_msg_printf("SetState: m_State set to %d\n", m_State);

}

/*----------------------------------------------------------------------
| SetUndimType
+---------------------------------------------------------------------*/
void
PocketTV::SetUndimType(UNDIM_TYPE type)
{
	switch (type) {
		case UNDIM_TYPE_NONE:
		case UNDIM_TYPE_HP_540:
		case UNDIM_TYPE_CASIO_115:
			break;
		default:
#ifdef MIPS
			{
				HKEY key;
				LONG ret;

				ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Drivers\\CASIO\\BackLight"), 0, 0, &key);

				if (ret == ERROR_SUCCESS) {
					type = UNDIM_TYPE_CASIO_115;
					RegCloseKey(key);
				} else {
					type = UNDIM_TYPE_NONE;
				}
			}
#elif defined (SH3)
			{
				HKEY key;
				LONG ret;
				TCHAR buffer[16];
				DWORD size = sizeof(buffer);
				DWORD actual_type;

				ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Platform"), 0, 0, &key);

				if (ret == ERROR_SUCCESS) {
					ret = RegQueryValueEx(key, TEXT("Manufacturer"), 0, (LPDWORD)&actual_type, (BYTE *)buffer, &size);

					if (ret == ERROR_SUCCESS && actual_type == REG_SZ) {
						if (_wcsicmp(buffer, TEXT("Hewlett-Packard")) == 0) {
							type = UNDIM_TYPE_HP_540;
						}
					}
					RegCloseKey(key);
				} else {
					type = UNDIM_TYPE_NONE;
				}
			}
#else
			type = UNDIM_TYPE_NONE;
#endif
			break;
	}

	SetRegistryValueDWORD(TEXT("UndimType"), type);
	m_UndimType = type;
}

/*----------------------------------------------------------------------
| EnumWindowsProc
+---------------------------------------------------------------------*/
BOOL CALLBACK
EnumWindowsProcKillDialodWindows(
HWND hwnd, 
LPARAM lParam)
{
	TCHAR buffer[128];
	const TCHAR *title;
	int ret;
	PocketTV *player = (PocketTV *)lParam;

	GetWindowText(hwnd, buffer, sizeofarray(buffer));

	title = MyLoadString((HINSTANCE)player->m_Instance, IDS_WINDOW_CAPTION_OPEN_FILE);
	ret = wcscmp(buffer, title);
	MyFreeString(title);

	if (ret == 0) {
		EndDialog(hwnd, 0);
		DestroyWindow(hwnd);
		return TRUE;
	}

	title = MyLoadString((HINSTANCE)player->m_Instance, IDS_WINDOW_CAPTION_ABOUT);
	ret = wcscmp(buffer, title);
	MyFreeString(title);

	if (ret == 0) {
		EndDialog(hwnd, 0);
		DestroyWindow(hwnd);
		return TRUE;
	}
	title = MyLoadString((HINSTANCE)player->m_Instance, IDS_WINDOW_CAPTION_STREAMING);
	ret = wcscmp(buffer, title);
	MyFreeString(title);

	if (ret == 0) {
		EndDialog(hwnd, 0);
		DestroyWindow(hwnd);
		return TRUE;
	}
	return TRUE;
}

/*----------------------------------------------------------------------
| HandleWindowsMessage
+---------------------------------------------------------------------*/
LRESULT
PocketTV::HandleWindowsMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) 
	{
//		case WM_HELP:
//			DialogBox(m_Instance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)DialogAbout);
//			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_OPEN_THIS_FILE:
					{
						TCHAR *file_to_open;
						HKEY key;
						DWORD type;
						DWORD size;
						int ret;

						ret = OpenPocketTVKey(&key);
						if (ret != ERROR_SUCCESS) {
							break;
						}
						ret = RegQueryValueEx(key, (LPCWSTR)TEXT("FileToOpen"), (PDWORD)0, (LPDWORD)&type, (LPBYTE)NULL, &size);
						if (ret == ERROR_SUCCESS) {
							file_to_open = (TCHAR *)malloc(size);
							if (file_to_open) {
								ret = RegQueryValueEx(key, (LPCWSTR)TEXT("FileToOpen"), (PDWORD)0, (LPDWORD)&type, (LPBYTE)file_to_open, &size);
							}
							RegDeleteValue(key, (LPCWSTR)TEXT("FileToOpen"));
						}
						RegCloseKey(key);
						if (file_to_open && m_Registered) {

							// close any opened dialog window, e.g. About...
							EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);

//							_msg_printf("IDM_OPEN_THIS_FILE, calling OpenURL %s\n", file_to_open);
							OpenURL((const TCHAR *)file_to_open);
							free((void *)file_to_open);

						}
					}
					break;
				case IDM_FILE_OPEN_URL:
					DialogBox(m_Instance, (LPCTSTR)IDD_OPEN_URL, hWnd, (DLGPROC)DialogOpenURL);
					break;
				case IDM_FILE_ABOUT:
					DialogBox(m_Instance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)DialogAbout);
					break;
//				case IDM_REGISTER:
//					if (!DialogBox(m_Instance, (LPCTSTR)IDD_REGISTER, hWnd, (DLGPROC)DialogRegister)) {
//						ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Invalid Key"));
//						DestroyWindow(hWnd);
//					}
					break;
				case IDOK:
#ifdef TAP_OK_TO_QUIT
					// user clicked OK button in the Nav bar
					if (m_FastVideo && m_State == MTVP_STATE_PLAYING) {
						SetState(MTVP_STATE_PAUSED);
					}
						
//					DestroyWindow(m_Window);
					ExitThread(0);	// faster than DestroyWindow(m_Window) ?
#else
					if (!m_Registered) {
//						DestroyWindow(hWnd);
						ExitThread(0);	// faster than DestroyWindow(m_Window) ?
					}

					if (m_CancelModePending) {
						m_CancelModePending = false;
					}
					OpenFile();
#endif
					break;
				case IDM_EXIT:
					// destroy window (causes player to exit when it receives WM_DESTROY)
//					_msg_printf("Exit\n");
//					DestroyWindow(hWnd);
					ExitThread(0);	// faster than DestroyWindow(m_Window) ?
					break;
				case IDM_CONTROLS_FFW:	// fall through!
				case IDM_CONTROLS_PLAY:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					if (m_State == MTVP_STATE_PLAYING) {
						SetState(MTVP_STATE_PAUSED);
						if (wmId == IDM_CONTROLS_FFW) {
							if (m_FastForward) {
//								MtvpSetRateFactor(1.0);
//								m_FastForward = false;
								break;
							}
						} else {	// IDM_CONTROLS_PLAY
							if (!m_FastForward) {
								break;
							}
						}
					}
					if (wmId == IDM_CONTROLS_FFW) {
						MtvpSetRateFactor(FAST_FORWARD_COEF);
						m_FastForward = true;
					} else {	// IDM_CONTROLS_PLAY
						MtvpSetRateFactor(1.0);
						m_FastForward = false;
					}
					if (m_State == MTVP_STATE_PAUSED_AT_END) {
						MySeek(0);
					}
					SetState(MTVP_STATE_PLAYING);
					break;
				case IDM_CONTROLS_STOP:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					SetState(MTVP_STATE_PAUSED);
					MySeek(0);
					break;
				case IDM_CONTROLS_STEP:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					if (m_State != MTVP_STATE_PAUSED) {
						SetState(MTVP_STATE_PAUSED);
					}
					MtvpSteps(1);
					MtvpGetPosition();
					break;

#ifdef USE_FULLSCREEN
				case IDM_FULLSCREEN:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					Fullscreen(true);
					break;
#endif
				case IDM_OPTIONS_AUDIO_CHANNEL_BOTH:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_BOTH);
					break;
				case IDM_OPTIONS_AUDIO_CHANNEL_LEFT:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_LEFT);
					break;
				case IDM_OPTIONS_AUDIO_CHANNEL_RIGHT:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_RIGHT);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_LOW:
					SetAudioQuality(MTVP_AUDIO_QUALITY_LOW);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_MEDIUM:
					SetAudioQuality(MTVP_AUDIO_QUALITY_MEDIUM);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_HIGH:
					SetAudioQuality(MTVP_AUDIO_QUALITY_HIGH);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_AUTO:
					SetVideoStretch(VOH_WIN32_STRETCH_AUTO);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_NEVER:
					SetVideoStretch(VOH_WIN32_STRETCH_NEVER);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_ALWAYS:
					SetVideoStretch(VOH_WIN32_STRETCH_ALWAYS);
					break;
//				case IDM_OPTIONS_VIDEO_STRETCH_FILL:
//					SetVideoStretch(VOH_WIN32_STRETCH_FILL);
//					break;
				case IDM_OPTIONS_VOLUME_RANGE_HALF:
					SetVolumeRange(2);
					break;
				case IDM_OPTIONS_VOLUME_RANGE_FULL:
					SetVolumeRange(1);
					break;
#if 0
				case IDM_OPTIONS_RATE_FACTOR_1_8:
					SetRateFactor(-8);
					break;
				case IDM_OPTIONS_RATE_FACTOR_1_4:
					SetRateFactor(-4);
					break;
				case IDM_OPTIONS_RATE_FACTOR_1_2:
					SetRateFactor(-2);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_2:
					SetRateFactor(2);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_4:
					SetRateFactor(4);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_8:
					SetRateFactor(8);
					break;
#endif // 0
				case IDM_OPTIONS_LOOP:
					Loop(CheckMenuItem(m_Menu, IDM_OPTIONS_LOOP, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_AUTO_PLAY:
					AutoPlay(CheckMenuItem(m_Menu, IDM_OPTIONS_AUTO_PLAY, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_DITHER:
					SetDither(CheckMenuItem(m_Menu, IDM_OPTIONS_DITHER, MF_CHECKED) != MF_CHECKED);
					break;
#ifdef USE_FULLSCREEN
				case IDM_OPTIONS_PLAY_FULLSCREEN:
					PlayFullscreen(CheckMenuItem(m_Menu, IDM_OPTIONS_PLAY_FULLSCREEN, MF_CHECKED) != MF_CHECKED);
					if (m_PlayFullscreen) {
//						ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, TEXT("Note: when playing in fullscreen mode, parts of the image will be cropped if it is larger than the display area (320x240)."));
						if (m_State == MTVP_STATE_PLAYING) {
							Fullscreen(true);
						}
					}
					break;
#endif
				case IDM_OPTIONS_SHOW_STATUS_WINDOW:
					ShowStatusBar(CheckMenuItem(m_Menu, IDM_OPTIONS_SHOW_STATUS_WINDOW, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_FAST_VIDEO:
					{
						bool yes = CheckMenuItem(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_CHECKED) != MF_CHECKED;
						if (yes) {
							const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_FAST_VIDEO_WARNING);
							ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
							MyFreeString(msg);
						}
						Gapi(yes);
						SetState(m_State);
					}
					break;
				case IDM_VOLUME:
					if (m_VolumeDialog) {
						if (m_CancelModePending) {
							m_CancelModePending = false;
							ResumeVideo();
						}
						if (IsWindowVisible(m_VolumeDialog)) {
							ShowWindow(m_VolumeDialog, SW_HIDE);
							SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_VOLUME, MAKELPARAM(0, 0));
						} else {
							int ret;
							ShowWindow(m_VolumeDialog, SW_SHOW);
							ret = SetWindowPos(m_VolumeDialog, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_SHOWWINDOW);
							SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_VOLUME, MAKELPARAM(1, 0));
						}
					}
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			break;
		case WM_PAINT:
//			RECT rt;
//			if (!m_CancelModePending) {

			{
				HDC hdc;
				PAINTSTRUCT ps;
				hdc = BeginPaint(hWnd, &ps);
#ifndef POCKET_PC
				if (m_ShowStatusBar) DrawStatusText(hdc, &m_StreamNameRect, m_StreamName ? m_StreamName : TEXT(""), 0);
#endif
				EndPaint(hWnd, &ps);
			}
			MtvpRepaint();
			break;
		case WM_SETFOCUS:

			SHFullScreen(m_Window, SHFS_SHOWTASKBAR/*|SHFS_HIDESIPBUTTON*/);
			ResumeVideo();
			MtvpFocus();
			SetNavBarText(m_Window, m_NavBarTitle);

#ifdef USE_FULLSCREEN
			if (m_Fullscreen) {
				SetForegroundWindow(m_FullscreenWindow);
			}
#endif

			break;
		case WM_KILLFOCUS:

			if ((HWND)wParam == m_VolumeDialog || (HWND)wParam == m_SeekSlider
#ifdef USE_FULLSCREEN
					|| (HWND)wParam == m_FullscreenWindow
#endif
					) {
				break;
			}
			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
//				SetState(MTVP_STATE_PAUSED);
				SuspendVideo();
//				Gapi0(false, false);
			}

#if 0
			if (m_FastVideo) {
				SuspendVideo();

				if (lParam) {
					InvalidateRect((HWND)lParam, (const RECT *)NULL, TRUE);
				} else {
					InvalidateRect((HWND)NULL, (const RECT *)NULL, TRUE);
				}
			}
			if (m_WasPlayingBeforeBecommingInactive == -1) {
				m_WasPlayingBeforeBecommingInactive = (m_State == MTVP_STATE_PLAYING);
			}
			SetState(MTVP_STATE_PAUSED);
#endif
			break;

		case WM_CANCELMODE:

			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI && m_State == MTVP_STATE_PLAYING) {

				SuspendVideo();
				m_CancelModePending = true;
				SetTimer(m_Window, ID_TIMER_CANCELMODE, TIMER_CANCELMODE_INTERVAL, 0);
			}
			break;
		case WM_INITMENUPOPUP:
			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
				if (m_CancelModePending) {
					ResumeVideo();
					m_CancelModePending = false;
				}
				SetState(MTVP_STATE_PAUSED);
				Gapi0(false, false);
			}
			break;
		case WM_ACTIVATE:
			if (!m_PlayerReady) {
				break;
			}
#ifdef USE_FULLSCREEN
			if ((HWND)lParam == m_FullscreenWindow) {
				break;
			}
#endif
			switch (LOWORD(wParam)) {
				case WA_ACTIVE:
				case WA_CLICKACTIVE:
//					_msg_printf("activate\n");

					if (m_Registered) {
						// close any opened dialog window, e.g. About...
						EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);
						
						if (!m_StreamOpened) {

							OpenFile();
						}
					}

					if (m_WasPlayingBeforeBecommingInactive == 1) {
						SetState(MTVP_STATE_PLAYING);
					}
					m_WasPlayingBeforeBecommingInactive = -1;
					break;
				case WA_INACTIVE:
//					_msg_printf("deactivate\n");

#ifdef USE_FULLSCREEN
					if (!m_Fullscreen)
#endif
										{
						if (m_WasPlayingBeforeBecommingInactive == -1) {
							if (m_FastVideo && m_CancelModePending) {
								m_WasPlayingBeforeBecommingInactive = MTVP_STATE_PLAYING;
							} else {
								m_WasPlayingBeforeBecommingInactive = (m_State == MTVP_STATE_PLAYING);
							}
						}
						SetState(MTVP_STATE_PAUSED);
					}
					
					break;
			}

			break;
#if 0
		case WM_NOTIFY:
			{
			NMHDR	*nmhdr = (NMHDR	*)lParam;
			if (nmhdr->hwndFrom == m_CommandBands) {
				if (nmhdr->code == RBN_HEIGHTCHANGE) {
					UpdateVideoTargetRect();
//				} else if (nmhdr->code == RBN_LAYOUTCHANGED) {
//					UpdateSlidersSize();
				}
			}
			}
			break;
#endif
		case WM_TIMER:
			if (!m_PlayerReady) {
				break;
			}

			switch (wParam) {
			case ID_TIMER_POSITION: {
					SYSTEMTIME  system_time;
					LONGLONG  file_time;

					// Check the system time.  If it shows that last time we looked
					// was earlier than 2 seconds before, we can assume that the machine
					// had been "powered-off" during some time.  "powered-off" means, 
					// in the case of WinCE, that the machine was put in its 'dormant' state.
					// The problem is that we have no idea of what event caused the machine
					// to wake-up.  It could be the user pressing the power button, but it
					// could also be some time alarm or other system even that cause the system
					// to power-up by itself.
					// If PocketTV was playing a video in 'loop' mode at the time the system
					// was turned off, it would start again, possible without the user knowing
					// about it, and it could drain the entire battery!
					// so, in order to avoid this unfortunate possibility, we decide to Pause
					// the player if we detect this situation.

//					if (m_DisplayReady) {
						GetSystemTime(&system_time);
						SystemTimeToFileTime(&system_time, (LPFILETIME)&file_time);

						if (m_LastPositionTimerTime != 0
									&& file_time > m_LastPositionTimerTime + (TIMER_POSITION_INTERVAL + 3000) * 10000L) {
							SetState(MTVP_STATE_PAUSED);
#ifdef USE_FULLSCREEN
							Fullscreen(false);
#endif
	//						ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("delta time %d\n"), (int)(file_time - m_LastPositionTimerTime));
						}
						m_LastPositionTimerTime = file_time;
//					}
					// note: m_LastPositionTimerTime MUST be reset to 0 each time m_DisplayReady is set to false.

					if (m_State == MTVP_STATE_PLAYING && !m_Seeking) {
						MtvpGetPosition();
					}
				}
				break;
			case ID_TIMER_FRAMERATE:
				MtvpGetActualFramerate();
				break;
			case ID_TIMER_KEEPALIVE:
				KeepAlive();
				break;
			case ID_TIMER_CANCELMODE:
				if (m_CancelModePending) {
					SetState(MTVP_STATE_PAUSED);
					ResumeVideo();
					m_CancelModePending = false;
//					MtvpRepaint();
//					MtvpResumeVideo();
				} else {
					ResumeVideo();
				}
				KillTimer(m_Window, ID_TIMER_CANCELMODE);
				break;
#ifdef POCKET_PC
			case ID_TIMER_KEEPBRIGHT:
				KeepBright();
				break;
#endif
			default:
				break;
			}
			break;
		case WM_HIBERNATE:
			CloseStream();
			break;
		case WM_DESTROY:
			DestroyControls();
			MtvpQuit();
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

/*--------------------------------------------------------------------------+
| SetVideoStretch0
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoStretch0(VOH_WIN32_STRETCH stretch)
{
	VOH_WIN32_CNTL data;
	data.handler_id = MTVP_VOH_HANDLER_ID_WIN32;
	data.type = VOH_WIN32_CNTL_TYPE_STRETCH;
	data.data.stretch = stretch;

	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);

	EnableDither(stretch);
}

/*--------------------------------------------------------------------------+
| SetVideoStretch
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoStretch(VOH_WIN32_STRETCH stretch)
{
	unsigned int wmId;

	m_Stretch = stretch;

	switch (stretch) {
		case VOH_WIN32_STRETCH_AUTO:	wmId = IDM_OPTIONS_VIDEO_STRETCH_AUTO; break;
		case VOH_WIN32_STRETCH_NEVER:	wmId = IDM_OPTIONS_VIDEO_STRETCH_NEVER; break;
		case VOH_WIN32_STRETCH_ALWAYS:	wmId = IDM_OPTIONS_VIDEO_STRETCH_ALWAYS; break;
//		case VOH_WIN32_STRETCH_FILL:	wmId = IDM_OPTIONS_VIDEO_STRETCH_FILL; break;
		default:						wmId = 0; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_VIDEO_STRETCH_FIRST,
						  IDM_OPTIONS_VIDEO_STRETCH_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	if (m_FastVideo) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_SIZE_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	} else {
		SetVideoStretch0(stretch);

		SetRegistryValueDWORD(TEXT("VideoStretch"), stretch);
	}
}

/*--------------------------------------------------------------------------+
| SetVolumeRange
+--------------------------------------------------------------------------*/
void
PocketTV::SetVolumeRange(unsigned int range)
{
	unsigned int wmId;

	m_VolumeRange = range;

	switch (range) {
		case 2:		wmId = IDM_OPTIONS_VOLUME_RANGE_HALF; break;
		default:	wmId = IDM_OPTIONS_VOLUME_RANGE_FULL; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_VOLUME_RANGE_FIRST,
						  IDM_OPTIONS_VOLUME_RANGE_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	SetRegistryValueDWORD(TEXT("VolumeRange"), m_VolumeRange);

	if (m_Volume >= 0) {
		MtvpOnNotifyVolume(m_Volume);
		MySetVolume(SendMessage(m_VolumeSlider, TBM_GETPOS, 0, 0));
	}
}


/*--------------------------------------------------------------------------+
| SetVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoTargetRect() 
{
	if (m_FastVideo) {
		GapiSetVideoTargetRect();
	}

	VOH_WIN32_CNTL data;
	data.handler_id = MTVP_VOH_HANDLER_ID_WIN32;
	data.type = VOH_WIN32_CNTL_TYPE_TARGET_RECT;
	data.data.target_rect = m_TargetRect;

	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
}

/*----------------------------------------------------------------------
| GetChildRect
+---------------------------------------------------------------------*/
static void
GetChildRect(
	HWND window,
	RECT *rect)
{
	RECT parent_rect;
	HWND parent;

	// get window rectangle in client coordinates (i.e. relative to parent window).

	GetWindowRect(window, rect);
	parent = GetParent(window);
	GetWindowRect(parent, &parent_rect);

	rect->top -= parent_rect.top;
	rect->left -= parent_rect.left;
	rect->bottom -= parent_rect.top;
	rect->right -= parent_rect.left;
}


/*--------------------------------------------------------------------------+
| CalculateVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::CalculateVideoTargetRect()
{
	GetClientRect(m_Window, &m_TargetRect);

#ifndef POCKET_PC
	m_TargetRect.top += CommandBands_Height(m_CommandBands);
#endif

	if (m_ShowStatusBar) {
#ifdef POCKET_PC
		{
			RECT status_rect;
			GetChildRect(m_StatusWindow, &status_rect);

			m_TargetRect.bottom = status_rect.top;
		}
#else
		m_TargetRect.bottom = m_StreamNameRect.top;
#endif
	} else {
		RECT seek_slider_rect;
		GetChildRect(m_SeekSlider, &seek_slider_rect);
		m_TargetRect.bottom = seek_slider_rect.top;
	}
}

/*--------------------------------------------------------------------------+
| UpdateVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateVideoTargetRect()
{
	CalculateVideoTargetRect();

	SetVideoTargetRect();
}

#if 0
/*--------------------------------------------------------------------------+
| UpdateSliderSize
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateSliderSize(HWND slider, HWND command_bar)
{
	RECT slider_rect;
	GetWindowRect(slider, &slider_rect);
	RECT commandbar_rect;
	GetWindowRect(command_bar, &commandbar_rect);
	MoveWindow(slider, slider_rect.left - commandbar_rect.left, slider_rect.top - commandbar_rect.top, 
		commandbar_rect.right - slider_rect.left, 
		slider_rect.bottom - slider_rect.top,
		TRUE);
}

/*--------------------------------------------------------------------------+
| UpdateSlidersSize
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateSlidersSize()
{
	UpdateSliderSize(m_SeekSlider, m_ControlsCommandBar);
	UpdateSliderSize(m_VolumeSlider, m_MenuCommandBar);
}
#endif /* 0 */

#if 0
/*--------------------------------------------------------------------------+
| get_time_string
+--------------------------------------------------------------------------*/
static const TCHAR *
get_time_string(
	int		sec
)
{
	static TCHAR buffer[9];

#if 0 /* Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
//	printf("sec = %d\n", sec);
#endif /* 0 - Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
	
	if (sec >= 0) {
		int		hh, mm, ss;

		hh = sec < 3600 ? 0 : sec / 3600;
		mm = (sec / 60) % 60;
		ss = sec % 60;
		
		if (hh > 99) {
			/*
			 * This can only happen if an absurd value of Video_bitrate
			 * or Mux_bitrate is received.  But if we don't test that,
			 * some bad streams can (and do) cause mtv to crash.
			 */
			swprintf(buffer, TEXT("??:??:??"));
		} else {
			swprintf(buffer, TEXT("%02d:%02d:%02d"), hh, mm, ss);
		}
		if (buffer[sizeofarray(buffer) - 1] != 0) abort_now();
		
		return buffer;
	} else {
		return TEXT("");
	}
}
#endif /* 0 */

/*--------------------------------------------------------------------------+
| get_time_string
+--------------------------------------------------------------------------*/
static const TCHAR *
get_time_string(
	int		sec
)
{
	static TCHAR buffer[8];

#if 0 /* Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
//	printf("sec = %d\n", sec);
#endif /* 0 - Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
	
	if (sec >= 0) {
		int		mm, ss;

		mm = sec / 60;
		ss = sec % 60;
		
		if (mm > 999) {
			/*
			 * This can only happen if an absurd value of Video_bitrate
			 * or Mux_bitrate is received.  But if we don't test that,
			 * some bad streams can (and do) cause mtv to crash.
			 */
			swprintf(buffer, TEXT("???:??"));
		} else {
			swprintf(buffer, TEXT("%02d:%02d"), mm, ss);
		}
		if (buffer[sizeofarray(buffer) - 1] != 0) abort_now();
		
		return buffer;
	} else {
		return TEXT("");
	}
}

/*--------------------------------------------------------------------------+
| ShowTimeTotal
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimeTotal()
{

//	printf("set_time_total, Bits_filesize = %u\n", Bits_filesize);

	if (m_Filesize == 0) {
		SendMessage(m_StatusWindow, SB_SETTEXT, 1, (LPARAM)TEXT(""));
	} else {
		int	sec;
		const TCHAR *time_str;
		
		sec = GetElapsedSeconds(m_Filesize);
	
		time_str = get_time_string(sec);

		SendMessage(m_StatusWindow, SB_SETTEXT, 1, (LPARAM)time_str);
		SendMessage(m_SeekSlider, TBM_SETRANGEMAX, TRUE, TRACK_SLIDER_MAX);
	}
//	InvalidateRect(m_StatusWindow, NULL, TRUE);
}


/*--------------------------------------------------------------------------+
| GetElapsedSeconds														|
+--------------------------------------------------------------------------*/
int
PocketTV::GetElapsedSeconds(
	unsigned int		pos
)
{
	if (m_PackInfos.mux_rate / BITS(char) != 0) {
		return (int)((unsigned int)pos / (m_PackInfos.mux_rate / BITS(char)));
	} else if (m_VideoInfos.bitrate / BITS(char) != 0) {
		return (int)((unsigned int)pos / (m_VideoInfos.bitrate / BITS(char)));
	} else {
		return -1;
	}
}

/*--------------------------------------------------------------------------+
| ShowTimePosition
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimePosition(unsigned int pos)
{
	const TCHAR *time_str;
	int	sec;

	sec = GetElapsedSeconds(pos);
	time_str = get_time_string(sec);
	
	SendMessage(m_StatusWindow, SB_SETTEXT, 0, (LPARAM)time_str);
	if (!m_Seeking && m_DisplayReady) {
		LPARAM slider_pos = (LPARAM)(pos * m_TrackSliderMaxOverFilesize);

		SendMessage(m_SeekSlider, TBM_SETPOS, TRUE, slider_pos);
#ifdef SEEK_SLIDER_SETSEL
		SendMessage(m_SeekSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, slider_pos));
#endif
//		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("setpos"));
	}
}

/*--------------------------------------------------------------------------+
| ShowTimeElapsed
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimeElapsed()
{
	ShowTimePosition(m_Position);
}

/*--------------------------------------------------------------------------+
| ShowBitrate
+--------------------------------------------------------------------------*/
void
PocketTV::ShowBitrate()
{
	TCHAR buf[20];
	int		bitrate = m_PackInfos.mux_rate ? m_PackInfos.mux_rate : m_VideoInfos.bitrate;

	if (bitrate != 0) {
		swprintf(buf, TEXT("%u Kb/s"), bitrate / 1000);

		SendMessage(m_StatusWindow, SB_SETTEXT, 3, (LPARAM)buf);
	} else {
		SendMessage(m_StatusWindow, SB_SETTEXT, 3, (LPARAM)TEXT(""));
	}
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyPackInfos
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyPackInfos(const MTVP_PMP_DATA_PACK_INFOS *ptr)
{
	m_PackInfos = *ptr;

	ShowTimeTotal();
	ShowBitrate();
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyVideoInfos
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyVideoInfos(const MTVP_PMP_DATA_VIDEO_INFOS *ptr)
{
	m_VideoInfos = *ptr;

	ShowTimeTotal();
	ShowBitrate();
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyFileSize
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyFileSize(unsigned int size)
{
	m_Filesize = size;
	m_TrackSliderMaxOverFilesize = (double)TRACK_SLIDER_MAX / m_Filesize;
	m_FilesizeOverTrackSliderMax = (double)m_Filesize * (1.0 / TRACK_SLIDER_MAX);

	ShowTimeTotal();
}

/*--------------------------------------------------------------------------+
| ShowActualFramerate
+--------------------------------------------------------------------------*/
void
PocketTV::ShowActualFramerate()
{
	if (m_ActualFramerate == 0) {
		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT(""));
	} else {
		TCHAR buf[20];
		swprintf(buf, TEXT("%4.2f fps"), m_ActualFramerate);

		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)buf);
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyActualFramerate
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyActualFramerate(double x)
{
	m_ActualFramerate = x;
	ShowActualFramerate();
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyPosition
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyPosition(int pos)
{
	if (pos != -1) {
		m_Position = pos;
	} else {
//		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("pos=0"));
		m_Position = 0;
	}

	ShowTimeElapsed();
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyDisplayReady
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyDisplayReady()
{
//	if (m_Seeking) {
//		GetPosition();
//	}

	if (m_PendingSeek >= 0) {
		MtvpSeek(m_PendingSeek);
		m_DisplayReady = false;
		m_PendingSeek = -1;
//		m_LastPositionTimerTime = 0;
	} else {
		m_DisplayReady = true;
	}
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyDisplayThreadId
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyDisplayThreadId(HANDLE thread)
{
	m_DisplayThread = thread;
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyVolume
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyVolume(double volume)
{

	if (!m_SettingVolume) {
		int slider_pos = VOLUME_SLIDER_MAX - NINT(volume * VOLUME_SLIDER_MAX * m_VolumeRange);

		m_Volume = volume;

		if (slider_pos < 0) {
			// means that the volume was higher than the max range (based on m_VolumeRange)
			// is this case we set the volume to the max range allowed.
			slider_pos = 0;
			MySetVolume(0);
		}


//		SendMessage(m_VolumeSlider, TBM_SETPOS, TRUE, NINT(volume * VOLUME_SLIDER_MAX));
		SendMessage(m_VolumeSlider, TBM_SETPOS, TRUE, slider_pos);
		SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(slider_pos, VOLUME_SLIDER_MAX));
		SendMessage(m_MenuCommandBar, TB_HIDEBUTTON , IDM_VOLUME, TRUE);
		SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(volume == 0 ? 15+5 : 15+4, 0));
		SendMessage(m_MenuCommandBar, TB_HIDEBUTTON , IDM_VOLUME, FALSE);
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyCannotShowVideo
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyCannotShowVideo(int status)
{
	TCHAR *p = get_msg_error_string(status);
	if (m_FastVideo) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_FAST_VIDEO_NOT_AVAILABLE);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, p ? p : L"", status);
		MyFreeString(msg);
	} else {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_VIDEO_NOT_AVAILABLE);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, p ? p : L"", status);
		MyFreeString(msg);
	}

	if (p) free(p);
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyCannotPlayAudio
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyCannotPlayAudio(int status)
{
	SetMute(true);
	const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_AUDIO_NOT_AVAILABLE);
	ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, status);
	MyFreeString(msg);
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyReady
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyReady()
{
	m_PlayerReady = true;
}

/*--------------------------------------------------------------------------+
| MySeek
+--------------------------------------------------------------------------*/
void
PocketTV::MySeek(unsigned int n)
{
	off_t pos = (off_t)(n * m_FilesizeOverTrackSliderMax);

//	SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("seek=0"));

#ifdef SEEK_SLIDER_SETSEL
	SendMessage(m_SeekSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, n));
#endif
	
	ShowTimePosition(pos);

	if (!m_DisplayReady) {
		m_PendingSeek = pos;
	} else {
		m_PendingSeek = -1;
		MtvpSeek(pos);
		m_DisplayReady = false;
//		m_LastPositionTimerTime = 0;
	}
}

/*--------------------------------------------------------------------------+
| MySetVolume
+--------------------------------------------------------------------------*/
void
PocketTV::MySetVolume(unsigned int slider_pos)
{
	m_Volume = (double)(VOLUME_SLIDER_MAX - slider_pos) / (VOLUME_SLIDER_MAX * m_VolumeRange);

	MtvpSetVolume(m_Volume);
	SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(slider_pos, VOLUME_SLIDER_MAX));
	if (!m_Muted) {
		SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(slider_pos == VOLUME_SLIDER_MAX ? 15+5 : 15+4, 0));
	}
}

#ifdef POCKET_PC
/*----------------------------------------------------------------------
| UnDimHP540
+---------------------------------------------------------------------*/
INLINE static void 
UnDimHP540()
{
	int ret;

	// UnDim() emulates a touch event and sends it to the display driver.
	// UnDim must be called at least every 9 sec to prevent auto-dimming.

	struct ContrastCmdInputParm {
		int	command;                       
		int	parm;
	} cip;

#define BRIGHTNESSCOMMAND           6160
#define BRIGHTNESS_CMD_EXTERNAL_EVENTS    6
#define EVENT_TOUCH                       1

	cip.command = BRIGHTNESS_CMD_EXTERNAL_EVENTS;
	cip.parm = EVENT_TOUCH;

	HDC hdc = GetDC(NULL);

	ret = ExtEscape(hdc, BRIGHTNESSCOMMAND, sizeof cip, (LPCSTR)&cip, 0, NULL);

	ReleaseDC(NULL, hdc);
}

/*----------------------------------------------------------------------
| UnDimCasio115
+---------------------------------------------------------------------*/
INLINE static void 
UnDimCasio115()
{
	// UnDim must be called at least every 14 sec to prevent auto-dimming.

	static HANDLE event;
	int ret;

	if (event == NULL) {
		event = CreateEvent(NULL, FALSE, FALSE, TEXT("BacklightTimerEvent"));
	}
	if (event != NULL) {
		ret = SetEvent(event);
	}
	// this does not seem to work when playing full-screen with direct screen access (GAPI).  why ??
}

#endif

/*----------------------------------------------------------------------
| KeepAlive
+---------------------------------------------------------------------*/
void 
PocketTV::KeepAlive()
{
	if (m_State == MTVP_STATE_PLAYING) {
		keybd_event(VK_LBUTTON, 0, KEYEVENTF_SILENT, 0);
	}
}

#ifdef POCKET_PC
/*----------------------------------------------------------------------
| KeepBright
+---------------------------------------------------------------------*/
void 
PocketTV::KeepBright()
{
	if (m_State == MTVP_STATE_PLAYING) {

		switch (m_UndimType) {
		case UNDIM_TYPE_HP_540:
			UnDimHP540();
			break;
		case UNDIM_TYPE_CASIO_115:
			UnDimCasio115();
			break;
		default:
			break;
		}
	}
}
#endif

/*----------------------------------------------------------------------
| SeekSliderProc
+---------------------------------------------------------------------*/
LRESULT 
PocketTV::SeekSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	if (!m_SeekSlider) {
        return CallWindowProc((WNDPROC)m_SeekSliderParentOriginalProc, 
                              window, message, wparam, lparam);
	}

    switch (message) {
      case WM_HSCROLL:
        switch(LOWORD(wparam)) {
          case SB_LINELEFT:
          case SB_LINERIGHT:
          case SB_PAGELEFT:
          case SB_PAGERIGHT:
            if (!m_Seeking) {
                m_Seeking = true;
				m_StateBeforeSeeking = m_State;
				SetState(MTVP_STATE_PAUSED);
            }
            MySeek(SendMessage(m_SeekSlider,
                                     TBM_GETPOS, 0, 0));
            break;

          case SB_ENDSCROLL:
			m_PendingSeek = -1;
            MtvpSeek((off_t)((double)SendMessage(m_SeekSlider,
                                     TBM_GETPOS, 0, 0) * m_FilesizeOverTrackSliderMax));
            if (m_Seeking) {
				m_Seeking = false;
				if (m_StateBeforeSeeking == MTVP_STATE_PLAYING) {
				   SetState(MTVP_STATE_PLAYING);
				}
			}
            break;
          case SB_THUMBPOSITION: 
          case SB_THUMBTRACK:
            if (m_Seeking == false) {
                m_Seeking = true;
				m_StateBeforeSeeking = m_State;
				SetState(MTVP_STATE_PAUSED);
            }
            MySeek(HIWORD(wparam));
			break;
        }
        break;

      default:
        return CallWindowProc((WNDPROC)m_SeekSliderParentOriginalProc, 
                              window, message, wparam, lparam);
    }

    return 0;
}

/*----------------------------------------------------------------------
|       RealSeekSliderProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
RealSeekSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
#ifdef NO_GLOBALS
    PocketTV *player = (PocketTV *)GetWindowLong(window, GWL_USERDATA);
#else
	PocketTV *player = Player;
#endif

	return player->SeekSliderProc(window, message, wparam, lparam);
}


/*----------------------------------------------------------------------
| VolumeSliderProc
+---------------------------------------------------------------------*/
LRESULT 
PocketTV::VolumeSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	if (!m_VolumeSlider) {
        return CallWindowProc((WNDPROC)m_VolumeSliderParentOriginalProc, 
                              window, message, wparam, lparam);
	}
    switch (message) {
      case WM_HSCROLL:
      case WM_VSCROLL:
        switch(LOWORD(wparam)) {
          case SB_LINELEFT:
          case SB_LINERIGHT:
          case SB_PAGELEFT:
          case SB_PAGERIGHT:
			  if (!m_SettingVolume) {
				  m_SettingVolume = true;
			  }
            MySetVolume(SendMessage(m_VolumeSlider,
                                     TBM_GETPOS, 0, 0));
            break;

          case SB_THUMBPOSITION: 
          case SB_ENDSCROLL:
            MySetVolume(SendMessage(m_VolumeSlider,
                                     TBM_GETPOS, 0, 0));
			  if (m_SettingVolume) {
				  m_SettingVolume = false;
			  }
            break;
          case SB_THUMBTRACK:
			  if (!m_SettingVolume) {
				  m_SettingVolume = true;
			  }
            MySetVolume(HIWORD(wparam));
			break;
        }
        break;

      default:
        return CallWindowProc((WNDPROC)m_VolumeSliderParentOriginalProc, 
                              window, message, wparam, lparam);
    }

    return 0;
}

/*----------------------------------------------------------------------
|       RealVolumeSliderProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
RealVolumeSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
#ifdef NO_GLOBALS
    PocketTV *player = (PocketTV *)GetWindowLong(window, GWL_USERDATA);
#else
	PocketTV *player = Player;
#endif

	return player->VolumeSliderProc(window, message, wparam, lparam);
}

/*----------------------------------------------------------------------
| VolumeDialogProc
+---------------------------------------------------------------------*/
BOOL 
PocketTV::VolumeDialogProc(
	HWND hwndDlg, 
	UINT uMsg, 
	WPARAM wParam, 
	LPARAM lParam )
{
	BOOL	lResult = TRUE;
  
	switch(uMsg) {

	case WM_COMMAND: {
		int wID = LOWORD(wParam);
		int wNotifyCode = HIWORD(wParam);

		switch (wID) {
			case IDOK:
			case IDCANCEL:
				if (wNotifyCode == BN_CLICKED) {
					ShowWindow(hwndDlg, SW_HIDE);
					SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_VOLUME, MAKELPARAM(0, 0));
				}
				break;
			case IDC_MUTE:
				if (wNotifyCode == BN_CLICKED) {
					bool muted;

					if (SendMessage(GetDlgItem(hwndDlg, IDC_MUTE), BM_GETCHECK, 0, 0) == BST_CHECKED) {
						muted = true;
					} else {
						muted = false;
					}
//					SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(muted ? 15+5 : 15+4, 0));
//					MtvpMute(muted);
//					m_Muted = muted;
					SetMute(muted);
				}
				break;
		}
		}
		return TRUE;

	case WM_ACTIVATE:
      return TRUE;
      
    case WM_INITDIALOG:
      {
        ;//Something
      }
      return TRUE;
      
    default:
      return FALSE;
      break;
	}
}

/*----------------------------------------------------------------------
|       RealVolumeDialogProc
+---------------------------------------------------------------------*/
BOOL CALLBACK 
RealVolumeDialogProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
#ifdef NO_GLOBALS
    PocketTV *player = (PocketTV *)GetWindowLong(GetParent(window), GWL_USERDATA);
#else
	PocketTV *player = Player;
#endif

	return player->VolumeDialogProc(window, message, wparam, lparam);
}


/*----------------------------------------------------------------------
| CreateSlider
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateSlider(
	HWND window,
	DWORD style,
	int x,
	int y, 
	int width,
	int height,
	WNDPROC *window_original_proc,
	WNDPROC slider_proc
)
{	
    // subclass the track command bar to trap slider messages 
#ifdef NO_GLOBALS
    SetWindowLong(window, GWL_USERDATA, (LONG)this);
#endif
    *window_original_proc = 
            (WNDPROC)GetWindowLong(window, GWL_WNDPROC);
    SetWindowLong(window, GWL_WNDPROC, (LONG)slider_proc);

    // create the track slider
    return CreateWindow( 
        TRACKBAR_CLASS, 
        NULL,
		style,
        x,
        y,
        width,
		height,
        window,
        NULL,
        m_Instance,
        NULL);
}

/*----------------------------------------------------------------------
| CreateSliderInCommandBar
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateSliderInCommandBar(
	HWND command_bar,
	unsigned int	last_button_index,
	WNDPROC *command_bar_original_proc,
	WNDPROC slider_proc
)
{
	RECT commandbar_rect;
	GetWindowRect(command_bar, &commandbar_rect);
	RECT last_button_rect;
	if (last_button_index == 0) {
		last_button_rect.left = last_button_rect.right = last_button_rect.top = 0;
		last_button_rect.bottom = commandbar_rect.bottom - commandbar_rect.top;
	} else {
		SendMessage(command_bar,
//#ifdef POCKET_PC
//			HDM_GETITEMRECT,
//#else
			TB_GETITEMRECT,
//#endif
					last_button_index, (LPARAM)&last_button_rect);
	}

	
    // subclass the track command bar to trap slider messages 
#ifdef NO_GLOBALS
    SetWindowLong(command_bar, GWL_USERDATA, (LONG)this);
#endif
    *command_bar_original_proc = 
            (WNDPROC)GetWindowLong(command_bar, GWL_WNDPROC);
    SetWindowLong(command_bar, GWL_WNDPROC, (LONG)slider_proc);

    // create the track slider
    return CreateWindow( 
        TRACKBAR_CLASS, 
        NULL,
        WS_CHILD        |
        WS_VISIBLE		| 
        TBS_BOTH		|
        TBS_NOTICKS,                
        last_button_rect.right,
        last_button_rect.top,
        commandbar_rect.right - commandbar_rect.left - last_button_rect.right,
		last_button_rect.bottom - last_button_rect.top,
        command_bar,
        NULL,
        m_Instance,
        NULL);
}

/*----------------------------------------------------------------------
| StopPlayTimers
+---------------------------------------------------------------------*/
void
PocketTV::StopPlayTimers()
{
	int		ret;

//	ret = KillTimer(m_Window, ID_TIMER_POSITION);
	ret = KillTimer(m_Window, ID_TIMER_FRAMERATE);
	ret = KillTimer(m_Window, ID_TIMER_KEEPALIVE);
#ifdef POCKET_PC
	ret = KillTimer(m_Window, ID_TIMER_KEEPBRIGHT);
#endif
//	m_LastPositionTimerTime = 0;
}

/*----------------------------------------------------------------------
| StartPlayTimers
+---------------------------------------------------------------------*/
void
PocketTV::StartPlayTimers()
{
	int		ret;

//	ret = SetTimer(m_Window, ID_TIMER_POSITION, TIMER_POSITION_INTERVAL, 0);
	ret = SetTimer(m_Window, ID_TIMER_FRAMERATE, TIMER_FRAMERATE_INTERVAL, 0);
	ret = SetTimer(m_Window, ID_TIMER_KEEPALIVE, TIMER_KEEPALIVE_INTERVAL, 0);
#ifdef POCKET_PC
	ret = SetTimer(m_Window, ID_TIMER_KEEPBRIGHT, TIMER_KEEPBRIGHT_INTERVAL, 0);
#endif
}

/*----------------------------------------------------------------------
| InitControls
+---------------------------------------------------------------------*/
void
PocketTV::InitControls()
{
	int ret;

	INITCOMMONCONTROLSEX icex;
	icex.dwSize = sizeof(icex);
	icex.dwICC  = ICC_BAR_CLASSES | ICC_COOL_CLASSES;
	InitCommonControlsEx(&icex);

	{
		LONG ret;
		DWORD disposition;
		HKEY key;

		ret = RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"), 0, NULL, 0, 0, 0, &key, &disposition);
		if (ret != ERROR_SUCCESS) {
			ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create registry key (error %d)"), GetLastError());
//			DestroyWindow(m_Window);
			ExitThread(0);
			return;
		}
		RegCloseKey(key);
		if (disposition == REG_CREATED_NEW_KEY) {
#if 0
			// in development...

			// we have created the key
			SYSTEMTIME system_time;
			FILETIME file_time;

			GetSystemTime(&system_time);
			SystemTimeToFileTime(&system_time, &file_time);

			ret = SetRegistryValue(TEXT("InstallTime"), REG_BINARY, (const BYTE *)&file_time, sizeof file_time);
#endif // 0

		} else if (disposition == REG_OPENED_EXISTING_KEY) {
			// the key already existed
		}
	}
	{
		// if PocketTV.lnk exists in both "\\Windows\\Start Menu" and "\\Windows\\Start Menu\\Programs",
		// remove the link in "\\Windows\\Start Menu\\Programs"
		TCHAR start_menu_programs_folder[MAX_PATH];		// TEXT("\\Windows\\Start Menu\\Programs")
		TCHAR start_menu_folder[MAX_PATH];				// TEXT("\\Windows\\Start Menu")
		TCHAR path[MAX_PATH];
		ITEMIDLIST *idl;

		// SHGetSpecialFolderPath(m_Window, start_menu_programs_folder, CSIDL_STARTMENU, false) does not work for some reason...
		SHGetSpecialFolderLocation(m_Window, CSIDL_STARTMENU, &idl);
		SHGetPathFromIDList(idl, start_menu_folder);

		SHGetSpecialFolderPath(m_Window, start_menu_programs_folder, CSIDL_PROGRAMS, false);

		HANDLE file;
		
		swprintf(path, TEXT("%s\\PocketTV.lnk"), start_menu_folder);
//		file = CreateFile(TEXT("\\Windows\\Start Menu\\PocketTV.lnk"),
		file = CreateFile(path,
							GENERIC_READ,
							FILE_SHARE_READ,
							NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
		if (file != INVALID_HANDLE_VALUE) {
			CloseHandle(file);

			swprintf(path, TEXT("%s\\PocketTV.lnk"), start_menu_programs_folder);
			DeleteFile(path);
//			DeleteFile(TEXT("\\Windows\\Start Menu\\Programs\\PocketTV.lnk"));
		}
	}


#ifdef NO_REGISTRATION
	m_Registered = true;
#else
	InitRegistration();
#endif

#ifdef POCKET_PC

	m_MenuCommandBar = CreateMenuBar(m_Window, IDM_MAIN, SHCMBF_HIDESIPBUTTON);

	m_Menu = (HMENU)SHMenuBar_GetMenu (m_MenuCommandBar, ID_FILE);

	if (!m_Menu) {
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_INTERNAL, TEXT("Cannot create menu (error %d)"), GetLastError());
//		DestroyWindow(m_Window);
		ExitThread(0);
		return;
	}
#else

	m_CommandBands = CommandBands_Create(m_Instance, m_Window, 0,
												RBS_VARHEIGHT | RBS_BANDBORDERS, NULL);
	CommandBands_AddAdornments(m_CommandBands, m_Instance, 0, 0);
	{
		REBARBANDINFO info[1] = {{0}};

		info[0].cbSize = sizeof(REBARBANDINFO);
		info[0].fMask = RBBIM_ID | RBBIM_STYLE;
		info[0].fStyle = RBBS_NOGRIPPER;
		info[0].wID = IDBAND_MENU;

		CommandBands_AddBands(m_CommandBands, m_Instance, sizeofarray(info), info);
	}

	m_MenuCommandBar = CommandBands_GetCommandBar(m_CommandBands, 0);

	CommandBar_InsertMenubar(m_MenuCommandBar, m_Instance, IDM_MAIN, 0);
	m_Menu = CommandBar_GetMenu(m_MenuCommandBar, 0); 


#endif

	CommandBar_AddBitmap(m_MenuCommandBar, HINST_COMMCTRL, IDB_STD_SMALL_COLOR , 0, 0, 0);
	CommandBar_AddBitmap(m_MenuCommandBar, m_Instance, IDB_CONTROLS, 4, 0, 0);
	TBBUTTON menu_buttons [] = {
#ifndef POCKET_PC
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
#endif
//		{STD_FILEOPEN, IDM_FILE_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{15+7, IDM_CONTROLS_STOP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{15+0, IDM_CONTROLS_PLAY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{15+6, IDM_CONTROLS_FFW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{15+2, IDM_CONTROLS_STEP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{15+4, IDM_VOLUME, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#ifdef USE_FULLSCREEN
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{15+3, IDM_FULLSCREEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#endif
	};
	CommandBar_AddButtons(m_MenuCommandBar, sizeofarray(menu_buttons), menu_buttons);

	static const TCHAR *menu_tooltips[sizeofarray(menu_buttons)];
	const TCHAR **p = menu_tooltips;
//	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_OPEN_FILE);
	*p++ = NULL;	// separator
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_STOP);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_PLAY_PAUSE);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_FFW_PAUSE);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_STEP);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_VOLUME);
#ifdef USE_FULLSCREEN
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_FULLSCREEN);
#endif
	CommandBar_AddToolTips(m_MenuCommandBar, sizeofarray(menu_tooltips), menu_tooltips);


	{
		RECT rect;
		GetWindowRect(m_Window, &rect);

		m_SeekSlider = CreateSlider(m_Window, WS_CHILD|WS_VISIBLE|TBS_BOTH|TBS_NOTICKS|TBS_ENABLESELRANGE/*|TBS_FIXEDLENGTH*/,                
							0, rect.bottom - rect.top - SEEK_SLIDER_HEIGHT, rect.right - rect.left, SEEK_SLIDER_HEIGHT,
							&m_SeekSliderParentOriginalProc, RealSeekSliderProc);
	}

	// create status window
	m_StatusWindow = CreateStatusWindow(WS_CHILD|WS_VISIBLE, NULL, m_Window, ID_STATUS_WINDOW);

//	int width[] = {60, 120, 180, -1};
//	int width[] = {40, 80, 140, 200, -1};
	int width[] = {37, 76, 134, 193, -1};
	SendMessage(m_StatusWindow, SB_SETPARTS, sizeofarray(width), (LPARAM)width);
	m_ShowStatusBar = true;
	{
		RECT rect;
		GetChildRect(m_StatusWindow, &rect);

		ret = SetWindowPos(m_StatusWindow,
							(HWND)0,
							0,
							rect.top - SEEK_SLIDER_HEIGHT,
							0,
							0,
							SWP_NOSIZE|SWP_NOZORDER|SWP_SHOWWINDOW);
	}


#ifndef POCKET_PC
	// determine location of  stream name rectangle (above status window)
	GetWindowRect(m_StatusWindow, &m_StreamNameRect);
	unsigned int height = m_StreamNameRect.bottom - m_StreamNameRect.top;
	m_StreamNameRect.top -= height + MENU_HEIGHT;
	m_StreamNameRect.bottom -= height + MENU_HEIGHT;
#endif

	m_VolumeDialog = CreateDialog(m_Instance, (LPCTSTR)IDD_VOLUME, m_Window, RealVolumeDialogProc);
	if (!m_VolumeDialog) {
		int status = GetLastError();
		TCHAR *p = get_msg_error_string(status);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_INTERNAL, TEXT("Cannot create volume dialog: %s (error %d)"), p ? p : L"", status);
		if (p) free(p);
//		DestroyWindow(m_Window);
		ExitThread(0);
		return;
	}
	{
		RECT window_rect;
		RECT status_rect;
		RECT volume_rect;
		GetWindowRect(m_Window, &window_rect);
		GetWindowRect(m_VolumeDialog, &volume_rect);
		GetChildRect(m_StatusWindow, &status_rect);

		ret = SetWindowPos(m_VolumeDialog,
							(HWND)0,
							window_rect.right - window_rect.left - (volume_rect.right - volume_rect.left),
							window_rect.bottom - window_rect.top - (volume_rect.bottom - volume_rect.top),
							0,
							0,
							SWP_NOSIZE|SWP_NOZORDER);
	}
	m_VolumeSlider = GetDlgItem(m_VolumeDialog, IDC_VOLUME_SLIDER);

	SendMessage(m_VolumeSlider, TBM_SETRANGEMAX, TRUE, VOLUME_SLIDER_MAX);
	SendMessage(m_VolumeSlider, TBM_SETTHUMBLENGTH, 20, 0);
	SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, VOLUME_SLIDER_MAX));
//	SendMessage(m_VolumeSlider, TBM_SETTICFREQ, 1, 0);

#ifdef NO_GLOBALS
	SetWindowLong(m_VolumeDialog, GWL_USERDATA, (LONG)this);
#endif
    m_VolumeSliderParentOriginalProc = 
            (WNDPROC)GetWindowLong(m_VolumeDialog, GWL_WNDPROC);
    SetWindowLong(m_VolumeDialog, GWL_WNDPROC, (LONG)RealVolumeSliderProc);


	// fire up the timers
	ret = SetTimer(m_Window, ID_TIMER_POSITION, TIMER_POSITION_INTERVAL, 0);

	bool fast_video_disabled;

	if (GapiInit() != 0) {
		DeleteMenu(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_BYCOMMAND);
		fast_video_disabled = true;
		m_FastVideo = false;
	} else {
		fast_video_disabled = false;
	}

	DWORD value;

	if (GetRegistryValueDWORD(TEXT("AudioChannel"), &value) == ERROR_SUCCESS) {
		SetAudioChannel((MTVP_AUDIO_CHANNEL)value);
	} else {
#ifdef ARM
		SetAudioChannel((MTVP_AUDIO_CHANNEL)MTVP_AUDIO_CHANNEL_BOTH);
#else
		SetAudioChannel((MTVP_AUDIO_CHANNEL)MTVP_AUDIO_CHANNEL_LEFT);
#endif
	}
	if (GetRegistryValueDWORD(TEXT("AudioQuality"), &value) == ERROR_SUCCESS) {
		SetAudioQuality((MTVP_AUDIO_QUALITY)value);
	} else {
		SetAudioQuality((MTVP_AUDIO_QUALITY)MTVP_AUDIO_QUALITY_MEDIUM);
	}
	if (GetRegistryValueDWORD(TEXT("VideoStretch"), &value) == ERROR_SUCCESS) {
		SetVideoStretch((VOH_WIN32_STRETCH)value);
	} else {
		SetVideoStretch((VOH_WIN32_STRETCH)VOH_WIN32_STRETCH_AUTO);
	}
	if (GetRegistryValueDWORD(TEXT("Loop"), &value) == ERROR_SUCCESS) {
		Loop(value != 0);
	} else {
		Loop(true);
	}
	if (GetRegistryValueDWORD(TEXT("AutoPlay"), &value) == ERROR_SUCCESS) {
		AutoPlay(value != 0);
	} else {
		AutoPlay(true);
	}
	if (GetRegistryValueDWORD(TEXT("StatusBar"), &value) == ERROR_SUCCESS) {
		ShowStatusBar(value != 0);
	} else {
		ShowStatusBar(true);
	}
	if (GetRegistryValueDWORD(TEXT("VolumeRange"), &value) == ERROR_SUCCESS) {
		SetVolumeRange(value);
	} else {
		SetVolumeRange(1);
	}
#ifdef USE_FULLSCREEN
	if (GetRegistryValueDWORD(TEXT("PlayFullscreen"), &value) == ERROR_SUCCESS) {
		PlayFullscreen(value != 0);
	} else {
		PlayFullscreen(false);
	}
#else
//	PlayFullscreen(false);
	DeleteMenu(m_Menu, IDM_OPTIONS_PLAY_FULLSCREEN, MF_BYCOMMAND);
#endif

	if (!fast_video_disabled) {
#ifdef ARM
//		EnableMenuItem(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_GRAYED);
		DeleteMenu(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_BYCOMMAND);
#else
		if (GetRegistryValueDWORD(TEXT("FastVideo"), &value) == ERROR_SUCCESS) {
			Gapi(value != 0);
		} else {
			Gapi(false);
		}
#endif
	}

#ifdef POCKET_PC
	if (GetRegistryValueDWORD(TEXT("UndimType"), &value) == ERROR_SUCCESS) {
		SetUndimType((UNDIM_TYPE)value);
	} else {
		SetUndimType(UNDIM_TYPE_GUESS);		
	}
#endif
	if (GetRegistryValueDWORD(TEXT("DitherType"), &value) == ERROR_SUCCESS) {
		DitherType(value);
	} else {
#ifdef MIPS
		DitherType(MTVP_DITHER_SPEC_15BIT);
#else
		DitherType(MTVP_DITHER_SPEC_12BIT);
#endif
	}
	if (GetRegistryValueDWORD(TEXT("Dither"), &value) == ERROR_SUCCESS) {
		Dither(value != 0);
	} else {
#if defined(MIPS) // || defined(NO_REGISTRATION)
		Dither(false);
#else
		Dither(true);
#endif
	}
#if 0
	if (GetRegistryValueDWORD(TEXT("RateFactor"), &value) == ERROR_SUCCESS) {
		RateFactor(value);
	} else {
		RateFactor(8);
	}
#endif // 0
	DeactivateStreamControls();
	UpdateVideoTargetRect();
}

/*----------------------------------------------------------------------
| DestroyControls
+---------------------------------------------------------------------*/
void
PocketTV::DestroyControls()
{
}

/*----------------------------------------------------------------------
| SetStreamControlsState
+---------------------------------------------------------------------*/
void
PocketTV::SetStreamControlsState(bool enabled)
{
	int	lparam = MAKELPARAM(enabled ? TBSTATE_ENABLED : TBSTATE_INDETERMINATE, 0);

	SendMessage(m_MenuCommandBar, TB_SETSTATE, IDM_CONTROLS_STOP, lparam);
	SendMessage(m_MenuCommandBar, TB_SETSTATE, IDM_CONTROLS_PLAY, lparam);
	SendMessage(m_MenuCommandBar, TB_SETSTATE, IDM_CONTROLS_STEP, lparam);
	SendMessage(m_MenuCommandBar, TB_SETSTATE, IDM_CONTROLS_FFW, lparam);

	int	state = enabled ? MF_ENABLED : MF_GRAYED;

	if (m_SeekSlider) {
		// enable/disable the track slider
		EnableWindow(m_SeekSlider, enabled);
	}
}

/*----------------------------------------------------------------------
| ActivateStreamControls
+---------------------------------------------------------------------*/
void
PocketTV::ActivateStreamControls()
{
	SetStreamControlsState(true);
}

/*----------------------------------------------------------------------
| DeactivateStreamControls
+---------------------------------------------------------------------*/
void
PocketTV::DeactivateStreamControls()
{
	SetStreamControlsState(false);
}

/*----------------------------------------------------------------------
| ReflectState
+---------------------------------------------------------------------*/
void
PocketTV::ReflectState()
{
	TBBUTTONINFO button;

	// Change the GUI aspect to reflect the new state

//	_msg_printf("state=%d\n", state);

	button.cbSize = sizeof button;
	button.dwMask = TBIF_IMAGE;

	if (m_State == MTVP_STATE_PLAYING) {
		int	i;

		// transform the play or ffw button into a pause button
		i = m_FastForward ? IDM_CONTROLS_FFW : IDM_CONTROLS_PLAY;
		button.iImage = 15+1;
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, i, (LPARAM)&button);
		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , i, MAKELPARAM(1, 0));

		// reset the other button to normal icon and unchecked state
		if (m_FastForward) {
			i = IDM_CONTROLS_PLAY;
			button.iImage = 15+0;
		} else {
			i = IDM_CONTROLS_FFW;
			button.iImage = 15+6;
		}
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, i, (LPARAM)&button);
		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , i, MAKELPARAM(0, 0));

		StartPlayTimers();

	} else {
		// reset both play and ffw buttons to normal icon and unchecked state
		button.iImage = 15+0;
		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_CONTROLS_PLAY, MAKELPARAM(0, 0));
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, IDM_CONTROLS_PLAY, (LPARAM)&button);
		button.iImage = 15+6;
		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_CONTROLS_FFW, MAKELPARAM(0, 0));
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, IDM_CONTROLS_FFW, (LPARAM)&button);

		StopPlayTimers();
		MtvpGetPosition();
		MtvpGetActualFramerate();

	}
}

/*----------------------------------------------------------------------
| MtvpOnNotifyState
+---------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyState(MTVP_STATE state)
{
//	_msg_printf("state=%d\n", state);

	if (m_Seeking && m_State == MTVP_STATE_PLAYING) {
		return;
	}

	// except for this case, m_State is set up-front, when the MtvpState
	// command is executed or when a file is opened/closed.
	if (state == MTVP_STATE_PAUSED_AT_END) {
		m_State = state;

		// in this case it's probably a good idea to reset the rate factor
		MtvpSetRateFactor(1.0);
		m_FastForward = false;

		ReflectState();
	}

//#ifdef MIPS
//	if (state == MTVP_STATE_PLAYING) {
//		SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
//	} else {
//		SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
//	}
//#endif
}


//
//  FUNCTION: InitApplication()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
/*----------------------------------------------------------------------
| InitApplication
+---------------------------------------------------------------------*/
static BOOL
InitApplication(HINSTANCE hInstance, const TCHAR *window_class_name)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE;
    wc.lpfnWndProc		= (WNDPROC) PocketTVWindowProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_POCKETTV));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= window_class_name;

	if (RegisterClass(&wc) == FALSE) return FALSE;
	return TRUE;
}

/*----------------------------------------------------------------------
| ParseCommandLine
+---------------------------------------------------------------------*/
static int
ParseCommandLine(TCHAR *cmdline, const TCHAR **argv)
{
	TCHAR *bufp;
	int argc;

	/* Parse a command line buffer into arguments */

	argc = 0;
	for ( bufp = cmdline; *bufp; ) {
		/* Skip leading whitespace */
		while ( iswspace(*bufp) ) {
			++bufp;
		}
		/* Skip over argument */
		if ( *bufp == L'"') {
			++bufp;
			if ( *bufp ) {
				if ( argv ) {
					argv[argc] = bufp;
				}
				++argc;
			}
			/* Skip over word */
			while ( *bufp && (*bufp != L'"') ) {
				++bufp;
			}
		} else {
			if ( *bufp ) {
				if ( argv ) {
					argv[argc] = bufp;
				}
				++argc;
			}
			/* Skip over word */
			while ( *bufp && ! iswspace(*bufp) ) {
				++bufp;
			}
		}
		if ( *bufp ) {
			if ( argv ) {
				*bufp = 0;
			}
			++bufp;
		}
	}
	if ( argv ) {
		argv[argc] = NULL;
	}
	return argc;
}

/*----------------------------------------------------------------------
| GetFirstParam
+---------------------------------------------------------------------*/
const TCHAR *
GetFirstParam(const TCHAR *lpCmdLine)
{
	const TCHAR **argv;
	int argc;
	const TCHAR *bufp;
	TCHAR *cmdline;
	const TCHAR *first_param;

	// return a pointer to a malloc'ed buffer that contains the first
	// parameter of the command line in ASCII format.

	/* Grab the command line (use alloca() on Windows) */
	bufp = lpCmdLine;

	cmdline = (TCHAR *)malloc(sizeof(TCHAR)*(wcslen(bufp)+1));
	if (!cmdline) return NULL;
	wcscpy(cmdline, bufp);

	/* Parse it into argv and argc */
	argc = ParseCommandLine(cmdline, NULL);

	argv = (const TCHAR **)malloc((argc+1)*(sizeof *argv));
	if (!argv) {
		free(cmdline);
		return NULL;
	}
	ParseCommandLine(cmdline, argv);

	if (argc > 0) {
		first_param = _wcsdup(argv[0]);
	} else {
		first_param = NULL;
	}
	free((void *)cmdline);
	free((void *)argv);

	return first_param;
}


/*----------------------------------------------------------------------
| InitInstance
+---------------------------------------------------------------------*/
static PocketTV *
InitInstance(HINSTANCE hInstance, const TCHAR *window_class_name, const TCHAR *window_title, int nCmdShow, TCHAR *pCommandLine)
{
	HWND	hWnd;
	PocketTV *player;

#ifdef POCKET_PC
//	CeSetThreadQuantum(GetCurrentThread(), 25);
#endif

	{
		int cx, cy;

		HideSip();

#ifdef POCKET_PC
		int iDelta;
		SIPINFO si = {0};

		si.cbSize = sizeof(si);
		SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);

		//Consider the menu at the bottom, please.
		iDelta = (si.fdwFlags & SIPF_ON) ? 0 : MENU_HEIGHT;
		cx = si.rcVisibleDesktop.right - si.rcVisibleDesktop.left;
		cy = si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top - iDelta;
#else
		cx = CW_USEDEFAULT;
		cy = CW_USEDEFAULT;
#endif

		{
			int flags;
#ifdef POCKET_PC
			// BUG WARNING:  There seems to be a very strange bug:
			// If the WS_EX_CAPTIONOKBTN flag is set, it is not possible to display the
			// Today page. SHInitDialog allows us to get the OK button without using
			// the WS_EX_CAPTIONOKBTN flag, and it seems to work fine (no problem with the Today page)

			flags = WS_VISIBLE;
//			flags = WS_VISIBLE|WS_EX_CAPTIONOKBTN;
//			flags = WS_POPUP;	// today test
//			flags = WS_VISIBLE;
#else
			flags = WS_POPUP;
#endif
			hWnd = CreateWindow(window_class_name, window_title, flags,
				0, MENU_HEIGHT, cx, cy, NULL, NULL, hInstance, NULL);
		}
		if (hWnd == 0) {
			return NULL;
		}

#ifdef POCKET_PC
		// BUG WARNING:  There seems to be a very strange bug:
		// If the WS_EX_CAPTIONOKBTN flag is set, it is not possible to display the
		// Today page. SHInitDialog allows us to get the OK button without using
		// the WS_EX_CAPTIONOKBTN flag, and it seems to work fine (no problem with the Today page)

		SHINITDLGINFO shidi;
		// Create an OK button.
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON;
		shidi.hDlg = hWnd;
		SHInitDialog(&shidi);

		// BUG WARNING:  There seems to be a very strange bug:
		// If the WS_EX_CAPTIONOKBTN flag is set when the main window is created,
		// it is not possible to display the Today page.  
		// The following 'trick' allows us to get the OK button without using
		// the WS_EX_CAPTIONOKBTN flag, and it seems to work fine (no problem with the Today page).

		// this is what should normally be used to get the OK button, but it causes a problem
		// with the Today page.  See BUG WARNING above.
//		SHDoneButton(hWnd, SHDB_SHOW);	// show OK button in Nav Bar
#endif	
	
	}


    // assign an icon for the window
	{
	    HICON icon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_POCKETTV), 
                                IMAGE_ICON,
                                16, 16, 0);
        SendMessage(hWnd, WM_SETICON, FALSE, (LPARAM)icon);
    }


	/*
	 * Start the player
	 */

	{
		static const char *mtvp_argv[] = {
			"mtvp",	/* name of the player (if no / in pathname, will search in PATH) */
//			"-a0",	/* disable audio */
//			"-w",	/* trace everything */
//			"-aw12",
//			"-w3",
//			"-w11",
//			"-w12",
//			"-w4",
			NULL,	/* must be NULL-terminated */
		};
		
		__try {
			player = new PocketTV(mtvp_argv, hInstance, hWnd);

#ifndef NO_GLOBALS
			Player = player;
#endif
		}

		__except(True) {
			int status = GetExceptionCode();
			player->ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot start PocketTV: (exception %d) - Try increasing Program memory"), status);
//			DestroyWindow(hWnd);
			ExitThread(0);
			return NULL;
		}
	}
	
#ifdef NO_GLOBALS
	SetWindowLong(hWnd, GWL_USERDATA, (LONG)player);
#endif

	player->MtvpSetDisplayWindow((int)hWnd);

	ShowWindow(hWnd, nCmdShow);
	SetForegroundWindow(hWnd);

	player->MtvpAutoPlay(False); // default is True. Make it False since we handle auto play better in the front-end

	player->InitControls();


#ifdef NDEBUG
	const TCHAR *file_to_open = GetFirstParam(pCommandLine);
	if (!file_to_open) {
		player->OpenFile();
	} else {
		player->OpenURL(file_to_open);
		free((void *)file_to_open);
	}
#else
	// The application seems to lock-up under debugger when it calls the 
	// Microsoft "Open File" dialog - probably a Microsoft bug.
	// So if the application is compiled for debug (NDEBUG *NOT* defined), we open a file at start-up.
	// Edit the following line to select a file that exists on the target device.

//	SendMessage(hWnd, WM_COMMAND, IDM_OPEN_THIS_FILE, 0);	// that was to test the IDM_OPEN_THIS_FILE message
//	player->OpenURL(TEXT("\\My Documents\\starwars.mpg"));
//	player->OpenURL(TEXT("\\My Documents\\intervu.mpg"));
	player->OpenURL(TEXT("\\My Documents\\topgun3d.mpg"));
//	player->OpenURL(TEXT("\\My Documents\\mummy.mpg"));
//	player->OpenURL(TEXT("\\My Documents\\heuris1.mpg"));
//	player->OpenURL(TEXT("\\My Documents\\torme.mpg"));
//	player->OpenURL(TEXT("\\My Documents\\warpuk1.mpg"));
#endif



	return player;
}


/*----------------------------------------------------------------------
| OpenFile
+---------------------------------------------------------------------*/
int
PocketTV::OpenFile()
{
	TCHAR name[MAX_PATH];
	bool was_playing_before = (m_State == MTVP_STATE_PLAYING);
	bool had_stream_opened_before = m_StreamOpened;
	int ret;
	const TCHAR *title;

	title = MyLoadString(m_Instance, IDS_WINDOW_CAPTION_OPEN_FILE);

	if (was_playing_before) {
		SetState(MTVP_STATE_PAUSED);
	}

	SetNavBarText(m_Window, title);

	// this should prevent WM_ACTIVATE with WA_ACTIVE to try to open a stream if none was opened.
	// WM_ACTIVATE with WA_ACTIVE is received immediately after the File Selector is closed!
	m_StreamOpened = true;

	m_InOpenDialog = true;
	if (ChooseOpenFile(m_Window, name, sizeofarray(name),
			FILE_CHOOSER_TYPE_MPEG_VIDEO, title)) {
		m_InOpenDialog = false;
		ret = OpenURL(name);
		if (ret == 0) {
			// if OpenURL() was successfull, the AutoPlay will take care of starting
			// the player if necessary, therefore we should not do it here.
			was_playing_before = false;

		} else {
			m_StreamOpened = had_stream_opened_before;
		}
	} else {
		m_InOpenDialog = false;
		// user selected 'cancel' in the open dialog.
		ret = -1;
		m_StreamOpened = had_stream_opened_before;
	}
	MyFreeString(title);

	// close any opened dialog window, e.g. About...
//	EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);


	// If no file was selected or if the file could not be opened, then we should
	// resume playback if the player was playing before entering OpenFile().
	if (was_playing_before) {
		SetState(MTVP_STATE_PLAYING);
	}
	// reset in the "normal" state so that WM_ACTIVATE (with WA_INACTIVE) will remember the state...
//	m_WasPlayingBeforeBecommingInactive = -1;

	SetNavBarText(m_Window, m_NavBarTitle);

	return ret;
}


/*----------------------------------------------------------------------
| CloseStream
+---------------------------------------------------------------------*/
void
PocketTV::CloseStream()
{
	if (m_NavBarTitle) {
		// do that before calling SetState() because SetState() calls
		// ReflectState(), which sets the stream name in the NavBar Title
		free(m_NavBarTitle);
		m_NavBarTitle = NULL;
		SetNavBarText(m_Window, NULL);
	}

	SetState(MTVP_STATE_PAUSED);
	MtvpCloseStream();
	DeactivateStreamControls();
	m_Filesize = 0;
	m_Position = 0;
	memset(&m_VideoInfos, 0, sizeof(m_VideoInfos));
	memset(&m_PackInfos, 0, sizeof(m_PackInfos));
	if (m_StreamName) {
		free(m_StreamName);
		m_StreamName = NULL;
	}
	ShowTimeElapsed();
	ShowTimeTotal();
	ShowBitrate();
	m_StreamOpened = false;
}


/*----------------------------------------------------------------------
| ActivateOtherInstance
+---------------------------------------------------------------------*/
static void
ActivateOtherInstance(HWND hWnd, const TCHAR *pCommandLine)
{
	const TCHAR *file_to_open = GetFirstParam(pCommandLine);

	// tell other instance of PocketTV to come to the foreground and to open a file,
	// if a parameter is specified.

	if (file_to_open) {
		HKEY key;
//		DWORD disposition;
		int ret;

		// put file name in registry, so that the other process can get it.

		ret = OpenPocketTVKey(&key);
//		ret = RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"), 0, NULL, 0, 0, 0, &key, &disposition);
		if (ret == ERROR_SUCCESS) {
//			ret = RegSetValueEx(key, TEXT("CommandLine"), 0, REG_SZ, (const BYTE *)pCommandLine, sizeof(TCHAR) * (wcslen(pCommandLine) + 1));
			ret = RegSetValueEx(key, TEXT("FileToOpen"), 0, REG_SZ, (const BYTE *)file_to_open, sizeof(TCHAR) * (wcslen(file_to_open) + 1));
			RegCloseKey(key);
		}
		if (ret == ERROR_SUCCESS) {

			// tell other instance to open this file
			SendMessage(hWnd, WM_COMMAND, IDM_OPEN_THIS_FILE, 0);
		}
		free((void *)file_to_open);
	}

	SetForegroundWindow(hWnd);
}

/*----------------------------------------------------------------------
|       CheckForOtherInstance
+---------------------------------------------------------------------*/
static HWND
CheckForOtherInstance(const TCHAR *class_name)
{
	CreateMutex(NULL, TRUE, class_name);
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
		// there is an other instance running

		// find it's window, activate it
		HWND previous = FindWindow(class_name, NULL);
		
    	return previous;
	} 
	return NULL;
}


/*----------------------------------------------------------------------
|       WinMain
+---------------------------------------------------------------------*/
int WINAPI
WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
	{
	MSG msg;
	HACCEL hAccelTable;
	const TCHAR	*window_title;			// The title bar text
	const TCHAR	*window_class_name;		// The window class name

#if defined(POCKET_PC)
#if defined(MIPS)
//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
//	CeSetThreadQuantum(GetCurrentThread(), 25);
	CeSetThreadQuantum(GetCurrentThread(), 10);
#elif defined (ARM)
	CeSetThreadQuantum(GetCurrentThread(), 10);
//	CeSetThreadQuantum(GetCurrentThread(), 25);
#endif
#endif

	// Initialize global strings
	window_class_name = (const TCHAR *)MyLoadString(hInstance, IDC_POCKETTV);
	window_title = (const TCHAR *)MyLoadString(hInstance, IDS_APP_TITLE);

//	CreateFile(TEXT("mpegtv_log.txt"), GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, TRUNCATE_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	// check if app is already running
	{
		HWND other_window;

		other_window = CheckForOtherInstance(window_class_name);
		if (other_window) {
			ActivateOtherInstance(other_window, lpCmdLine);
			return 0;
		}
	}

	if (!InitApplication(hInstance, window_class_name)) {
		return 0;
	}

	// Perform application initialization:
	PocketTV *player = InitInstance (hInstance, window_class_name, window_title, nCmdShow, lpCmdLine);

	if (player == NULL) {
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_POCKETTV);


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {
		if (player->m_VolumeDialog && IsDialogMessage(player->m_VolumeDialog, &msg)) {
			continue;
		}

		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	
	return msg.wParam;
}

// eof
